# Auto-generated by EclipseNSIS Script Wizard
# 29/03/2010 12:05:07 PM

RequestExecutionLevel Admin

# General Symbol Definitions
!define PRODNAME "Rinstrum C500 Viewer"
!define REGKEY "SOFTWARE\${PRODNAME}"
!define VERSION "Filled In By Makefile"
!define COMPANY "Rinstrum"
!define URL "www.rinstrum.com"


Name "${PRODNAME}"


# MUI Symbol Definitions
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install-colorful.ico"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_STARTMENUPAGE_REGISTRY_ROOT HKLM
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${REGKEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME StartMenuGroup
!define MUI_STARTMENUPAGE_DEFAULTFOLDER Rinstrum
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall-colorful.ico"
!define MUI_UNFINISHPAGE_NOAUTOCLOSE

# Included files
!include Sections.nsh
!include MUI2.nsh
!include x64.nsh

# Variables
Var StartMenuGroup

# Installer pages
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_STARTMENU Application $StartMenuGroup
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

# Installer languages
!insertmacro MUI_LANGUAGE English

# Installer attributes
OutFile Filled_In_By_Makefile
InstallDir $PROGRAMFILES\Rinstrum\C500-510
CRCCheck on
XPStyle on
ShowInstDetails show
VIProductVersion 0.0.0.0
VIAddVersionKey ProductName "${PRODNAME}"
VIAddVersionKey ProductVersion "${VERSION}"
VIAddVersionKey CompanyName "${COMPANY}"
VIAddVersionKey CompanyWebsite "${URL}"
VIAddVersionKey FileVersion "${VERSION}"
VIAddVersionKey FileDescription ""
VIAddVersionKey LegalCopyright ""
InstallDirRegKey HKLM "${REGKEY}" Path
ShowUninstDetails show

# Installer sections
Section -Main SEC0000

    # Copy C520 viewer software to PC
    SetOutPath $INSTDIR
    SetOverwrite on
    File ..\c520_src\C500Viewer.exe
    File ..\c520_src\range1.bmp
    File ..\c520_src\range2.bmp
    File ..\c520_src\setp.bmp
    File .\C500Viewer.ini
    File ..\c520_src\C500Viewerkey.KB2
    File ..\c520_src\C500Viewerlcd.KB2
    File ..\c520_src\C500-303.jpg

    # Copy C510 viewer software to PC
    File ..\c510_src\C510Viewer.exe
    #File ..\c510_src\range1.bmp
    #File ..\c510_src\range2.bmp
    #File ..\c510_src\setp.bmp
    File .\C510Viewer.ini
    File ..\c510_src\C510Viewerkey.KB2
    File ..\c510_src\C510Viewerlcd.KB2
    File ..\c510_src\C500-A20.jpg

    # Copy USB slave driver to PC
    SetOutPath $TEMP\Driver
    File ..\Driver\c500.cat
    File ..\Driver\c500.inf

    # Remove the Windows 7/8/10 magic relocated ini file (if it exists)
    Delete /REBOOTOK "$LOCALAPPDATA\VirtualStore\Program Files (x86)\Rinstrum\C500-510\C500_510.ini"
    Delete /REBOOTOK "$LOCALAPPDATA\VirtualStore\Program Files (x86)\Rinstrum\C500-510\C500Viewer.ini"
    Delete /REBOOTOK "$LOCALAPPDATA\VirtualStore\Program Files (x86)\Rinstrum\C500-510\C510Viewer.ini"

    WriteRegStr HKLM "${REGKEY}\Components" Main 1
SectionEnd

# Install C500 USB slave driver
Section -InstallDriver SEC0001
    SetOverwrite on
    DetailPrint "Install C500 USB slave driver"

    # Install USB slave driver if desired
    ${If} ${Cmd} `MessageBox MB_YESNO|MB_ICONQUESTION "Install C500 USB slave driver?" IDYES`
        ${DisableX64FSRedirection}
        nsExec::ExecToLog '"$WINDIR\system32\PnPutil.exe" -i -a "$TEMP\Driver\c500.inf"'
        Pop $0
        ${EnableX64FSRedirection}
    ${EndIf}

    WriteRegStr HKLM "${REGKEY}\Components" InstallDriver 1
SectionEnd

Section -post SEC0002
    WriteRegStr HKLM "${REGKEY}" Path $INSTDIR
    SetOutPath $INSTDIR
    WriteUninstaller $INSTDIR\uninstall.exe
    !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    SetOutPath $INSTDIR
    CreateDirectory "$SMPROGRAMS\$StartMenuGroup"
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\Rinstrum C500 Viewer.lnk"
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Rinstrum C520 Viewer.lnk" $INSTDIR\C500Viewer.exe
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Rinstrum C510 Viewer.lnk" $INSTDIR\C510Viewer.exe
    CreateShortcut "$SMPROGRAMS\$StartMenuGroup\Uninstall $(^Name).lnk" $INSTDIR\uninstall.exe
    !insertmacro MUI_STARTMENU_WRITE_END
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayName "$(^Name)"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayVersion "${VERSION}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" Publisher "${COMPANY}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" URLInfoAbout "${URL}"
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" DisplayIcon $INSTDIR\uninstall.exe
    WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" UninstallString $INSTDIR\uninstall.exe
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoModify 1
    WriteRegDWORD HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)" NoRepair 1
SectionEnd

# Macro for selecting uninstaller sections
!macro SELECT_UNSECTION SECTION_NAME UNSECTION_ID
    Push $R0
    ReadRegStr $R0 HKLM "${REGKEY}\Components" "${SECTION_NAME}"
    StrCmp $R0 1 0 next${UNSECTION_ID}
    !insertmacro SelectSection "${UNSECTION_ID}"
    GoTo done${UNSECTION_ID}
next${UNSECTION_ID}:
    !insertmacro UnselectSection "${UNSECTION_ID}"
done${UNSECTION_ID}:
    Pop $R0
!macroend

# Uninstaller sections
Section /o -un.Main UNSEC0000
    # Remove C520 viewer
    Delete /REBOOTOK $INSTDIR\C500Viewer.exe
    Delete /REBOOTOK $INSTDIR\range1.bmp
    Delete /REBOOTOK $INSTDIR\range2.bmp
    Delete /REBOOTOK $INSTDIR\setp.bmp
    Delete /REBOOTOK $INSTDIR\C500Viewer.ini
    Delete /REBOOTOK $INSTDIR\C500Viewerkey.kb2
    Delete /REBOOTOK $INSTDIR\C500Viewerlcd.kb2
    Delete /REBOOTOK $INSTDIR\C500-303.jpg

    # Remove C510 viewer
    Delete /REBOOTOK $INSTDIR\C510Viewer.exe
    #Delete /REBOOTOK $INSTDIR\range1.bmp
    #Delete /REBOOTOK $INSTDIR\range2.bmp
    #Delete /REBOOTOK $INSTDIR\setp.bmp
    Delete /REBOOTOK $INSTDIR\C510Viewer.ini
    Delete /REBOOTOK $INSTDIR\C510Viewerkey.kb2
    Delete /REBOOTOK $INSTDIR\C510Viewerlcd.kb2
    Delete /REBOOTOK $INSTDIR\C500-A20.jpg

    # Remove USB slave driver
    Delete /REBOOTOK $INSTDIR\Driver\c500.cat
    Delete /REBOOTOK $INSTDIR\Driver\c500.inf

    # Remove the Windows 7/8/10 magic relocated ini file (if it exists)
    Delete /REBOOTOK "$LOCALAPPDATA\VirtualStore\Program Files (x86)\Rinstrum\C500-510\C500_510.ini"
    Delete /REBOOTOK "$LOCALAPPDATA\VirtualStore\Program Files (x86)\Rinstrum\C500-510\C500Viewer.ini"
    Delete /REBOOTOK "$LOCALAPPDATA\VirtualStore\Program Files (x86)\Rinstrum\C500-510\C510Viewer.ini"

    DeleteRegValue HKLM "${REGKEY}\Components" Main
SectionEnd

Section /o -un.InstallDriver UNSEC0001
    DeleteRegValue HKLM "${REGKEY}\Components" InstallDriver
SectionEnd

Section -un.post UNSEC0002
    DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\$(^Name)"
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\Uninstall $(^Name).lnk"
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\Rinstrum C520 Viewer.lnk"
    Delete /REBOOTOK "$SMPROGRAMS\$StartMenuGroup\Rinstrum C510 Viewer.lnk"
    Delete /REBOOTOK $INSTDIR\uninstall.exe
    DeleteRegValue HKLM "${REGKEY}" StartMenuGroup
    DeleteRegValue HKLM "${REGKEY}" Path
    DeleteRegKey /IfEmpty HKLM "${REGKEY}\Components"
    DeleteRegKey /IfEmpty HKLM "${REGKEY}"
    RmDir /REBOOTOK $SMPROGRAMS\$StartMenuGroup
    RmDir /REBOOTOK $INSTDIR
SectionEnd

# Installer functions
Function .onInit
    InitPluginsDir
FunctionEnd

# Uninstaller functions
Function un.onInit
    ReadRegStr $INSTDIR HKLM "${REGKEY}" Path
    !insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuGroup
    !insertmacro SELECT_UNSECTION Main ${UNSEC0000}
FunctionEnd
