unit comms;

interface

uses
  classes;

const
   MaxParams = 20;

type Tcommsobj = class

 private
   IntParams: array[0..MaxParams-1] of integer;
   DpPosParams: array[0..MaxParams-1] of integer;
   IntParamsOk: array[0..MaxParams-1] of boolean;
   StrParams: TStringList;
 public
   function getIntParam(p: integer; var val: integer; var dp_pos: integer; max, min: integer): boolean;
   function getStrParam(p: integer; var val: string; max_len, min_len: integer): boolean;
   function ParseStr(s: string; ishex: boolean; full: boolean): boolean;
   constructor Create;
   destructor Destroy; override;
 end;


implementation



{ Tcommsobj }

constructor Tcommsobj.Create;
begin
  StrParams := TStringList.Create();
end;

destructor Tcommsobj.Destroy;
begin
  StrParams.Free();
  inherited;
end;

function Tcommsobj.getIntParam(p: integer; var val: integer; var dp_pos: integer;
   max,min: integer): boolean;
var
  temp: integer;
begin
  if p >= MaxParams then result := FALSE
  else if (not IntParamsOk[p]) then result := FALSE
  else begin
    temp := IntParams[p];
    if ((temp < min) or (temp > max)) then result := FALSE
    else begin
       val := temp;
       dp_pos := DpPosParams[p];
       result := TRUE;
       end;
  end;
end;

function Tcommsobj.getStrParam(p: integer; var val: string; max_len,
  min_len: integer): boolean;
var
  temp: integer;
begin
  if p >= MaxParams then result := FALSE
  else if p >= StrParams.count then result := FALSE
  else begin
    temp := length(StrParams.strings[p]);
    if ((temp < min_len) or (temp > max_len)) then result := FALSE
    else begin
      val := StrParams.strings[p];
      result := TRUE;
    end;
  end;
end;

function Tcommsobj.ParseStr(s: string; ishex: boolean; full: boolean): boolean;
var
  i, pos, temp, base, start, dp_pos: integer;
  int_ok : integer;
  quotes_found, minus: boolean;
  temp_str: string;
  ch : char;
procedure add_param();
begin
  if not quotes_found then begin
   StrParams.Add(temp_str);
   temp_str := '';
   if (int_ok = 1) and  minus then temp := - temp;
   IntParams[pos] := temp;
   DpPosParams[pos] := dp_pos;
   IntParamsok[pos] := (int_ok = 1);
   inc(pos);
   int_ok := 0;
   temp := 0;
   minus := FALSE;
  end;
end;

begin
  StrParams.Clear();
  for i := 0 to MaxParams - 1 do begin
    IntParams[i] := 0;
    IntParamsOk[i] := FALSE;
  end;
  minus := false;

  if ishex then
     base := 16
  else
     base := 10;

  if full then start := 4 else start := 1;

  quotes_found := FALSE;
  temp_str := '';
  pos := 0;
  dp_pos := 0;
  temp := 0;
  int_ok := 0;
  for i := start to length(s) do begin
    ch := s[i];
    case ch of
      ',': if not quotes_found then begin
              if (dp_pos <> 0) then dp_pos := i - dp_pos - 1;
              add_param();
              dp_pos := 0;
             end;
      '"': begin
             quotes_found := not quotes_found;
             if quotes_found then temp_str := '';
           end;

      ' ': ;
      '.': dp_pos := i;
      '+': ;
      '-': minus := TRUE;
      else
         if ch in ['0'..'9'] then begin
           temp := temp * base + ord(ch) - ord('0');
           int_ok := 1;
         end else if ishex and (ch in ['A'..'F']) then begin
           temp := temp * base + 10 + ord(ch) - ord('A');
           int_ok := 1;
         end else if ishex and (ch in ['a'..'f']) then begin
           temp := temp * base + 10 + ord(ch) - ord('a');
           int_ok := 1;
         end else begin
           int_ok := 2;
           temp := 0;
         end;
      end;
      if ((ch <> '"') and (quotes_found or (ch <> ','))) then temp_str := temp_str + ch;
    end;
   add_param();
   result := (not quotes_found) and (pos > 0);
end;

end.
