unit trafficdlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, AdPort, comms;

type
  TFrmTraffic = class(TForm)
    PBprogress: TProgressBar;
    Animate: TAnimate;
    btnCancel: TButton;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }


    msg_sent: boolean;
    waiting, tries: integer;
    completed_ok: boolean;

  public
    { Public declarations }
     comms_list: Tstringlist; { commands to be transmitted  }
     msg_data: Tstringlist;   {list of expected responses which is used to hold actual responses }
     cmd_index: integer;
     Parser5100: TcommsObj;

     procedure clear_msgs();
     procedure handle_msg(var msg: string; reading: boolean);
     procedure add_msg(cmd: string; reply: string);
     procedure add_msg_list(cmd_list, reply_list: TstringList);    { info to instrument }
  end;

var
  FrmTraffic: TFrmTraffic;

implementation

{$R *.DFM}

uses main;

procedure TfrmTraffic.handle_msg(var msg: string; reading: boolean);
begin
  if (msg <> '?') then
  begin
    if msg = '?' then msg := '';
    if msg_sent then begin
      msg_sent := false;
      tries := 0;
      msg_data[cmd_index] := msg_data[cmd_index] + msg;
      inc(cmd_index);
    end;
    PBProgress.position := PBProgress.position + 1;
  end;
  waiting := 0;
end;

procedure TfrmTraffic.add_msg(cmd: string; reply: string);
begin
   comms_list.Add(cmd);
   msg_data.Add(reply);
   PBprogress.max := PBprogress.max+1;
end;

procedure TfrmTraffic.clear_msgs();
begin
  msg_data.clear();
  comms_list.clear();
  PBprogress.Max := 0;
  cmd_index := 0;
end;


procedure TfrmTraffic.add_msg_list(cmd_list, reply_list: TstringList);
var
  i: integer;
begin
  clear_msgs();
{  add_msg('S99;',''); }
  for i:= 0 to cmd_list.Count - 1  do add_msg(cmd_list[i],reply_list[i]);
end;


procedure TFrmTraffic.Timer1Timer(Sender: TObject);
begin

    if (waiting = 0) then begin
         if cmd_index < comms_list.Count then begin
           if ((tries = 0) or (msg_data[cmd_index] <> '')) then begin
              frmmain.SendStr(comms_list[cmd_index],false);

              if (msg_data[cmd_index] = '') then begin
                 waiting := 5;
                 tries := 0;
                 msg_sent := false;
                 inc(cmd_index);
              end else begin
                 waiting := 200;
                 inc(tries);
                 msg_sent := True;
                end;
             end;

           if (tries > 3) then begin
             Animate.Active := False;
             completed_ok := FALSE;
             comms_list.Clear();
             msg_data.clear();
             ShowMessage('Instrument Not Responding');
             modalresult := mrcancel;
           end;
         end else begin
           modalresult := mrok;
//           if msg_sent then modalresult := mrok
//           else begin msg_sent := TRUE; waiting := 50; end;
         end;
    end else  dec(waiting);
end;

procedure TFrmTraffic.FormCreate(Sender: TObject);
begin
   comms_list :=  Tstringlist.create();
   msg_data := Tstringlist.create();

end;

procedure TFrmTraffic.FormDestroy(Sender: TObject);
begin
   comms_list.destroy;
end;

procedure TFrmTraffic.FormActivate(Sender: TObject);
begin
  msg_sent := false;
  waiting := 2;
  tries := 0;
  completed_ok := TRUE;

end;

procedure TFrmTraffic.btnCancelClick(Sender: TObject);
begin
  comms_list.clear();
  waiting := 0;
  msg_sent := FALSE;
  msg_data.clear();
end;

end.
