unit ChartSetup;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFrmChartSetup = class(TForm)
    BtnOk: TButton;
    BtnCancel: TButton;
    EdtTstart: TEdit;
    LblXAxis: TLabel;
    Label3: TLabel;
    EdtComment: TEdit;
    label2: TLabel;
    EdtTend: TEdit;
    Label1: TLabel;
    Label4: TLabel;
    Edtminwgt: TEdit;
    LblMinUnits: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    EdtMaxWgt: TEdit;
    LblMaxUnits: TLabel;
    BtnAuto: TButton;
    procedure EdtXaxisExit(Sender: TObject);
    procedure EdtXaxisKeyPress(Sender: TObject; var Key: Char);
    procedure EdtYaxisExit(Sender: TObject);
    procedure EdtYaxisKeyPress(Sender: TObject; var Key: Char);
    procedure BtnAutoClick(Sender: TObject);
    procedure BtnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    dp: integer;
  end;

var
  FrmChartSetup: TFrmChartSetup;

implementation

{$R *.DFM}


uses tools, main, chart, TeEngine, dmViewer;

procedure TFrmChartSetup.EdtYaxisExit(Sender: TObject);
var tmp: integer;
  Edit : TEdit;
begin
  if Sender is TEdit then
  begin
    Edit := Sender as TEdit;
    Edit.Text := fmt_num(Edit.Text, dp, datViewer.DecimalPointChar);
    tmp := my_strtoint(Edit.Text);
    if ((tmp < -999999) or (tmp > 999999)) then
    begin
      MessageDlg(Format('Out of Range: (%s to %s)',
                        [fmt_int(-999999, dp, datViewer.DecimalPointChar),
                         fmt_int(999999, dp, datViewer.DecimalPointChar)]),
                 mtError, [mbOK], 0);
      SetFocus;
    end;
  end;
end;

procedure TFrmChartSetup.EdtYaxisKeyPress(Sender: TObject; var Key: Char);
begin
 case key of
      ' ','+','-','.',',':;
      #13: begin
               with sender as Tedit do
                  text := fmt_num(text, dp, datViewer.DecimalPointChar);
               key := #0;
             end
      else
        if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then key := #0;
     end;
end;


procedure TFrmChartSetup.EdtXaxisExit(Sender: TObject);
var tmp: integer;
  Edit : TEdit;
begin
  if Sender is TEdit then
  begin
    Edit := Sender as TEdit;
    Edit.Text := fmt_num(Edit.Text, 0, datViewer.DecimalPointChar);
    tmp := my_strtoint(Edit.Text);
    if ((tmp < 0) or (tmp > 1000)) then
    begin
      MessageDlg(Format('Out of Range: (%s to %s)',
                        [fmt_int(10, 0, datViewer.DecimalPointChar),
                         fmt_int(1000, 0, datViewer.DecimalPointChar)]),
                 mtError, [mbOK], 0);
      SetFocus;
    end;
  end;
end;

procedure TFrmChartSetup.EdtXaxisKeyPress(Sender: TObject; var Key: Char);
begin
    case key of
      ' ','+','-','.',',':;
      #13: begin
               with sender as Tedit do
                  text := fmt_num(text, 0, datViewer.DecimalPointChar);
               key := #0;
             end
      else
        if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then key := #0;
     end;
end;

procedure TFrmChartSetup.BtnAutoClick(Sender: TObject);
var margin: Double;
begin
  try
    EdtTstart.Text := '0';
    EdtTend.Text := Format('%f', [FrmMain.Series1.XValues.MaxValue]);
    margin := (FrmMain.Chart.MaxYValue(FrmMain.Chart.LeftAxis) - FrmMain.Chart.MinYvalue(FrmMain.Chart.LeftAxis)) / 10;
    EdtMaxWgt.Text := Format('%f', [FrmMain.Chart.MaxYValue(FrmMain.Chart.Leftaxis) + margin]);
    EdtMinWgt.Text := Format('%f', [FrmMain.Chart.minYValue(FrmMain.Chart.Leftaxis) - margin]);
  except
    on E: Exception do
      MessageDlg(E.Message, mtError, [mbOk], E.helpcontext);
  end;
end;

procedure TFrmChartSetup.BtnOkClick(Sender: TObject);
begin
  try
    if str_to_double(EdtTstart.text) >= str_to_double(EdtTend.text) then begin
      MessageDlg('Start time MUST be less than End time!',mtWarning,[mbOK],0);
      exit;
    end;
    if str_to_double(EdtMinWgt.text) >= str_to_double(EdtMaxWgt.text) then begin
      MessageDlg('Min weight MUST be less than Max weight!',mtWarning,[mbOK],0);
      exit;
    end;

    ModalResult := mrOK;
  except
    on EConvertError do MessageDlg('Invalid Number',mtWarning,[mbOK],0);
  end;
end;

end.
