unit kenMimic2;

// Title: Ken Mimic
// Author: Ken Bray
// Date: 27 May 2003
// Description:
//   TKenMimic provides a base class and a common denominator for a proposed
//   range of indicator mimic displays.  It is very general.
//
// Usage:
//   Define and implement a module with this class as its ancestor.  Be sure to
//   implement the DrawLCD procedure.
//
// Example: An example implementation exists called R300LCDTest.
//
// Other notes:

interface
uses kenbutton2, kenlcd2, extctrls;

type
  TKenMimic = class (Timage)  //todo TPaintBox
  protected
    fLCDLeft, fLCDTop, fLCDWidth, fLCDHeight : integer;
  public
    lcd : TKenLCD;
    btns : TKenLcdButtons;
    backgroundFilename : string;

    procedure DrawLCD(); virtual; abstract;
  published
    property LCDLeft : integer read fLCDLeft write flcdleft;
    property LCDTop : integer read fLCDTop write fLCDTop;
    property LCDWidth : integer read fLCDWidth write flcdWidth;
    property LCDHeight : integer read fLCDHeight write flcdHeight;
  end;

implementation

end.
