unit logdialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CheckLst, loginfo;

const
  // These match CBLogRate.Items
  LOG_RATE_IDX_AUTO = 0;
  LOG_RATE_IDX_10HZ = 1;
  LOG_RATE_IDX_1HZ = 2;
  LOG_RATE_IDX_10SEC = 3;

  NUM_DIGITAL_LOG_SERIES = 8;

type
  TLoggingMode = (lmOff, lmMSVStream, lmMSVPoll);

  TFrmLogDialog = class(TForm)
    CBLogRate: TComboBox;
    Label1: TLabel;
    BtnOk: TButton;
    BtnCancel: TButton;
    gboxSingle: TGroupBox;
    Label2: TLabel;
    label3: TLabel;
    label4: TLabel;
    label5: TLabel;
    CBxDig1: TComboBox;
    CBxDig2: TComboBox;
    CBxDig3: TComboBox;
    CBxDig4: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    CBxDig5: TComboBox;
    CBxDig6: TComboBox;
    CBxDig7: TComboBox;
    CBxDig8: TComboBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    CBxs : Array[0..NUM_DIGITAL_LOG_SERIES - 1] of TComboBox;
  public
    { Public declarations }
    // Get the selected logging rate in milliseconds between samples, 0 means using indicator sync rate generated
    function GetLoggingRate: Integer;
    function GetLoggingMode: TLoggingMode;
    function GetLoggingType(series : Integer): Integer;
  end;

var
  FrmLogDialog: TFrmLogDialog;

implementation

{$R *.DFM}

// Get the selected logging rate in milliseconds between samples, 0 means using indicator sync rate generated
function TFrmLogDialog.GetLoggingRate: Integer;
begin
  case CBLogRate.ItemIndex of
    LOG_RATE_IDX_AUTO: Result := 0;
    LOG_RATE_IDX_10HZ: Result := 100;
    LOG_RATE_IDX_1HZ: Result := 1000;
    LOG_RATE_IDX_10SEC: Result := 10000;
  else
    Result := 0;
  end;
end;

function TFrmLogDialog.GetLoggingMode: TLoggingMode;
begin
  case CBLogRate.ItemIndex of
    LOG_RATE_IDX_AUTO: Result := lmMSVStream;
  else
    Result := lmMSVPoll;
  end;
end;

procedure TFrmLogDialog.FormCreate(Sender: TObject);
var i, j : Integer;
begin
  CBLogRate.ItemIndex := 0;

  CBxs[0] := CBxDig1;
  CBxs[1] := CBxDig2;
  CBxs[2] := CBxDig3;
  CBxs[3] := CBxDig4;
  CBxs[4] := CBxDig5;
  CBxs[5] := CBxDig6;
  CBxs[6] := CBxDig7;
  CBxs[7] := CBxDig8;

  for i := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
  begin
    CBxs[i].Items.Clear();
    for j := 0 to NUM_LOG_TYPE_IDX - 1 do
      CBxs[i].Items.Add(LogTypeNames[j]);
    CBxs[i].ItemIndex := 0;
  end;
end;


function TFrmLogDialog.GetLoggingType(series : Integer): Integer;
begin
  case series of
    0,1,2,3,4,5,6,7:
      Result := CBxs[series].ItemIndex;
  else
    Result := LOG_TYPE_IDX_NONE;
  end;
end;

end.
