unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ComCtrls, ToolWin, Menus, StdCtrls, Mask, Spin, TeeProcs,
  TeEngine, Chart, ExtCtrls, AdPort, comms, Series,
  database, math, Buttons, IOIface, IOIFaceConfigure,
  kenmimicdisp, logging, CEVersionInfo, HHPack, logdialog, loginfo,
  indicator_model;

type
  TPollStatusThread = class(TThread)
  public procedure Execute; override;
end;

  TOctetArray = Array[0..3] of Integer;

  Tcallback = procedure(s: string);

  TCommsMode = (CMidle,CMMimic,CMlogging,CMtest,CMRead, CMWrite, CMCal,
                CMZero, CMSpan, CMLin);

  TFrmMain = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Edit1: TMenuItem;
    ChartSetup: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    ToolBar: TToolBar;
    StatusBar: TStatusBar;
    Help1: TMenuItem;
    ImageList: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    PgCMain: TPageControl;
    TSDisplay: TTabSheet;
    TSSettings: TTabSheet;
    TSLog: TTabSheet;
    TSTest: TTabSheet;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    Panel1: TPanel;
    MemoRx: TMemo;
    EdtSendStr: TEdit;
    BtnSend: TButton;
    CbStxEtx: TCheckBox;
    BtnClear: TButton;
    Panel2: TPanel;
    Chart: TChart;
    BtnStart: TButton;
    N3: TMenuItem;
    Connect2: TMenuItem;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Timer1: TTimer;
    Series1: TFastLineSeries;
    Series2: TLineSeries;
    PrinterSetupDialog: TPrinterSetupDialog;
    In1: TMenuItem;
    ReadSettings1: TMenuItem;
    WriteSettings1: TMenuItem;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    TSCal: TTabSheet;
    lblCsrPos: TLabel;
    Series3: TLineSeries;
    Series4: TLineSeries;
    Series5: TLineSeries;
    BtnStop: TButton;
    About1: TMenuItem;
    N2: TMenuItem;
    Print1: TMenuItem;
    helpsocket: TigAppHelpSocket;
    gbxCal: TGroupBox;
    lblCalWeight: TLabel;
    lblCalWeightUnits: TLabel;
    BtnZero: TButton;
    BTnSpan: TButton;
    EdtCalWeight: TEdit;
    gbxMVCal: TGroupBox;
    edtCalDirectZero: TEdit;
    edtCalDirectSpan: TEdit;
    btnCalDirect: TButton;
    lblDirectZero: TLabel;
    lblDirectSpan: TLabel;
    lblDirectZeroUnits: TLabel;
    lblDirectSpanUnits: TLabel;
    gbxBackupCal: TGroupBox;
    btnRestoreCal: TBitBtn;
    btnBackupCal: TBitBtn;
    pnlDispFill: TPanel;
    pnlDispCal: TPanel;
    Series6: TLineSeries;
    Series7: TLineSeries;
    Series8: TLineSeries;
    Series9: TLineSeries;
    MnuDeviceFinder: TMenuItem;
    ToolButtonDeviceFinder: TToolButton;
    mnuDecimalPoint: TMenuItem;
    mnuDPPoint: TMenuItem;
    mnuDPComma: TMenuItem;
    MnuOptions: TMenuItem;
    GBxLin: TGroupBox;
    lblLinearisationWeight: TLabel;
    lblLCalWeightUnits: TLabel;
    LBxLCal: TListBox;
    BtnLSet: TButton;
    BtnLClear: TButton;
    EdtLCalWeight: TEdit;
    ClearChart1: TMenuItem;
    PgCSettings: TPageControl;
    TSBuild: TTabSheet;
    lblDecimalPoint: TLabel;
    lblBuildUnits: TLabel;
    lblBuildType: TLabel;
    lblFullScale1: TLabel;
    lblResolution1: TLabel;
    lblFullScale2: TLabel;
    lblResolution2: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    lblSyncFrequency: TLabel;
    lblSyncFrequencyHz: TLabel;
    lblFS2Units: TLabel;
    lblFS1Units: TLabel;
    lblAddTare: TLabel;
    lblAddTareUnits: TLabel;
    CBxDP: TComboBox;
    EdtFS1: TEdit;
    CkBHiRes: TCheckBox;
    EdtFs2: TEdit;
    CBxRes1: TComboBox;
    CBxRes2: TComboBox;
    CBxUnits: TComboBox;
    CBxWeighMode: TComboBox;
    edtAddTare: TEdit;
    cbxFilter: TComboBox;
    TSOption: TTabSheet;
    Bevel1: TBevel;
    lblUse: TLabel;
    lblFilter: TLabel;
    lblJitter: TLabel;
    lblMotion: TLabel;
    lblAutoZero: TLabel;
    lblZeroTrack: TLabel;
    lblZeroRange: TLabel;
    Bevel4: TBevel;
    lblZeroBand: TLabel;
    lblZbandUnits: TLabel;
    CBxMode: TComboBox;
    CBxMotion: TComboBox;
    CBxZTrac: TComboBox;
    CBxAvSetting: TComboBox;
    CBxJitter: TComboBox;
    CBxZRange: TComboBox;
    CBxAZero: TComboBox;
    EdtZband: TEdit;
    TSSpecial: TTabSheet;
    GBFrontKeySettings: TGroupBox;
    lblFrontKeyZero: TLabel;
    lblFrontKeyTare: TLabel;
    lblFrontKeyGN: TLabel;
    lblBuzzerEnable: TLabel;
    lblFunction1: TLabel;
    lblFunction2: TLabel;
    lblFunction3: TLabel;
    lblBrightness: TLabel;
    CBxGbut: TComboBox;
    CBxTbut: TComboBox;
    CBxZBut: TComboBox;
    cbBuzEn: TComboBox;
    cbFunction1: TComboBox;
    cbF1Enable: TComboBox;
    cbFunction2: TComboBox;
    cbFunction3: TComboBox;
    cbF2Enable: TComboBox;
    cbF3Enable: TComboBox;
    cbBrightness: TComboBox;
    GBInputFunction: TGroupBox;
    lblRemoteInput1: TLabel;
    lblRemoteInput2: TLabel;
    lblRemoteInput3: TLabel;
    lblRemoteInput4: TLabel;
    lblRemoteInput5: TLabel;
    lblRemoteInput6: TLabel;
    lblRemoteInput7: TLabel;
    lblRemoteInput8: TLabel;
    CBxRem1: TComboBox;
    CBxRem2: TComboBox;
    CBxRem3: TComboBox;
    CBxRem4: TComboBox;
    CBxRem5: TComboBox;
    CBxRem6: TComboBox;
    CBxRem7: TComboBox;
    CBxRem8: TComboBox;
    TSSerialPorts: TTabSheet;
    tcSerial: TTabControl;
    cbSerialUse: TComboBox;
    cbBaud: TComboBox;
    cbParity: TComboBox;
    cbHardware: TComboBox;
    cbTermEn: TComboBox;
    cbDtrEn: TComboBox;
    cbDatabits: TComboBox;
    cbStopbits: TComboBox;
    tsEthernet: TTabSheet;
    GBEthernet: TGroupBox;
    lblDHCP: TLabel;
    lblIPAddress: TLabel;
    lblNetmask: TLabel;
    lblGateway: TLabel;
    lblDns1: TLabel;
    lblMacAddress: TLabel;
    lblHostname: TLabel;
    cbEthDHCP: TComboBox;
    edtEthAddr1: TEdit;
    edtEthAddr2: TEdit;
    edtEthAddr3: TEdit;
    edtEthMask1: TEdit;
    edtEthMask2: TEdit;
    edtEthMask3: TEdit;
    edtEthGW1: TEdit;
    edtEthGW2: TEdit;
    edtEthGW3: TEdit;
    edtEthDns1Octet1: TEdit;
    edtEthDns1Octet2: TEdit;
    edtEthDns1Octet3: TEdit;
    edtEthMAC1: TEdit;
    edtEthMAC2: TEdit;
    edtEthMAC3: TEdit;
    edtEthAddr4: TEdit;
    edtEthMAC4: TEdit;
    edtEthMAC5: TEdit;
    edtEthMAC6: TEdit;
    edtEthDns1Octet4: TEdit;
    edtEthGW4: TEdit;
    edtEthMask4: TEdit;
    edtEthHostname: TEdit;
    TSSetpoint: TTabSheet;
    CtrlSetpoint: TTabControl;
    lblSetpointType: TLabel;
    Bevel7: TBevel;
    lblSource: TLabel;
    lblLogic: TLabel;
    lblAlarm: TLabel;
    lblInflightUnits: TLabel;
    lblHysteresisUnits: TLabel;
    lblInflight: TLabel;
    lblHysteresis: TLabel;
    lblTarget: TLabel;
    lblTargetUnits: TLabel;
    lblLock: TLabel;
    CBxSetpType: TComboBox;
    CBxSetpSrc: TComboBox;
    CBxSetpLogic: TComboBox;
    CBxSetpAlarm: TComboBox;
    EdtInflight: TEdit;
    EdtHysteresis: TEdit;
    EdtTarget: TEdit;
    CbxSetpLock: TComboBox;
    TSAnalog: TTabSheet;
    Bevel5: TBevel;
    lblAnalogSource: TLabel;
    lblAnalogType: TLabel;
    lblAnalogZero: TLabel;
    lblAnalogSpan: TLabel;
    cbAnlSource: TComboBox;
    cbAnlType: TComboBox;
    CkBAbsolute: TCheckBox;
    CkBClip: TCheckBox;
    EdtAnlZero: TEdit;
    EdtAnlSpan: TEdit;
    TSClock: TTabSheet;
    GBMaintDate: TGroupBox;
    lblMaintYear: TLabel;
    lblMaintMonth: TLabel;
    lblMaintDay: TLabel;
    CkBQafEnable: TCheckBox;
    cbQafDay: TComboBox;
    cbQafMonth: TComboBox;
    cbQafYear: TComboBox;
    GBDateTime: TGroupBox;
    lblTimeHour: TLabel;
    lblTimeMinute: TLabel;
    lblTimeSecond: TLabel;
    lblTimeDay: TLabel;
    lblTimeMonth: TLabel;
    lblTimeYear: TLabel;
    cbClkHour: TComboBox;
    cbClkMinute: TComboBox;
    cbClkSecond: TComboBox;
    cbClkYear: TComboBox;
    cbClkMonth: TComboBox;
    cbClkDay: TComboBox;
    btnSysClock: TButton;
    TSSerialSettings: TTabSheet;
    GBNetworkSettings: TGroupBox;
    lblSerialAddress: TLabel;
    lblSerialUnitName: TLabel;
    cbAddress: TComboBox;
    EdtID: TEdit;
    GBPrinterSettings: TGroupBox;
    lblCustomTicket: TLabel;
    lblPrintType: TLabel;
    lblPrintSpaceRows: TLabel;
    lblPrintSpaceCols: TLabel;
    lblPrintHeader: TLabel;
    EdtPFmt: TEdit;
    CBxPMode: TComboBox;
    EDtRows: TEdit;
    EdtCols: TEdit;
    MemoHeader: TMemo;
    GBAutooutSettings: TGroupBox;
    lblAutooutCustom: TLabel;
    lblAutooutType: TLabel;
    lblAutooutSource: TLabel;
    EdtAFmt: TEdit;
    CBxAType: TComboBox;
    CBxASrc: TComboBox;
    GBUnitSwitch: TGroupBox;
    lblSecondaryUnits: TLabel;
    CBSecondaryUnits: TComboBox;
    lblTertiaryUnits: TLabel;
    CBTertiaryUnits: TComboBox;
    CBShowLbOz: TComboBox;
    lblShowLbOz: TLabel;
    GBTimeDateFormats: TGroupBox;
    lblTimeFormat: TLabel;
    CBTimeFormat: TComboBox;
    CBDateFormat: TComboBox;
    lblDateFormat: TLabel;
    lblSerialUse: TLabel;
    lblBaudRate: TLabel;
    lblParityBits: TLabel;
    lblDataBits: TLabel;
    lblStopBits: TLabel;
    lblHardware: TLabel;
    lblTermEn: TLabel;
    lblDtrEn: TLabel;
    GBModbusSettings: TGroupBox;
    lblModbusPort: TLabel;
    lblModbusEndian: TLabel;
    EdtMbPort: TEdit;
    cbMbEndian: TComboBox;
    lblPrintInterlock: TLabel;
    CBPrintInterlock: TComboBox;
    EdtConversionFactor: TEdit;
    lblConversionFactor: TLabel;
    lblSetpTiming: TLabel;
    CBSetpTiming: TComboBox;
    lblSetpReset: TLabel;
    CBSetpReset: TComboBox;
    TSSetpOpt: TTabSheet;
    GBSetpGenOpt: TGroupBox;
    CBSetpOptFeederType: TComboBox;
    lblSetpOptFeederType: TLabel;
    lblSetpOptDelayCheck: TLabel;
    EdtSetpOptDelayCheck: TEdit;
    lblSetpOptDelayCheckUnits: TLabel;
    TSSerialNet: TTabSheet;
    GBUdpO1: TGroupBox;
    lblUdpDestIP1: TLabel;
    lblUdpDestPort1: TLabel;
    lblUdpDestUse1: TLabel;
    edtDest1IP1: TEdit;
    edtDest1IP2: TEdit;
    edtDest1IP3: TEdit;
    edtDest1IP4: TEdit;
    edtUdpDest1: TEdit;
    cbUdpDest1Use: TComboBox;
    GBTcpIn1: TGroupBox;
    lblSerNetPort: TLabel;
    lblSerNetTimeout: TLabel;
    edtSerialNetPort: TEdit;
    edtSerialNetTimeout: TEdit;
    edtEthSearchDomain: TEdit;
    edtEthDns2Octet1: TEdit;
    edtEthDns2Octet2: TEdit;
    edtEthDns2Octet3: TEdit;
    edtEthDns2Octet4: TEdit;
    edtEthDns3Octet1: TEdit;
    edtEthDns3Octet2: TEdit;
    edtEthDns3Octet3: TEdit;
    edtEthDns3Octet4: TEdit;
    lblDns2: TLabel;
    lblDns3: TLabel;
    lblEthSearchDomain: TLabel;
    lblAutoStartChar: TLabel;
    edtAutoStartChar: TEdit;
    edtAutoEndChar1: TEdit;
    lblAutoEndChar1: TLabel;
    lblEndChar2: TLabel;
    edtAutoEndChar2: TEdit;
    CkBSenseLine: TCheckBox;
    EdtSetpJogOn: TEdit;
    lblSetpOptJogOn: TLabel;
    lblSetpJogOnUnits: TLabel;
    EdtSetpJogOff: TEdit;
    lblSetpJogOff: TLabel;
    lblSetpJogOffUnits: TLabel;
    EdtSetpOptJogSet: TEdit;
    lblSetpOptJogSet: TLabel;
    EdtSetpOptMaxJogSets: TEdit;
    lblSetpOptMaxJogSets: TLabel;
    lblButton1: TLabel;
    lblButton2: TLabel;
    lblKeyFn: TLabel;
    GBTcpIn2: TGroupBox;
    lblSerAutoPort: TLabel;
    edtSerialAutoPort: TEdit;
    lblSerAutoTimeout: TLabel;
    edtSerialAutoTimeout: TEdit;
    lblTcpIn2Type: TLabel;
    CBSerialAutoType: TComboBox;
    GBUdpO2: TGroupBox;
    lblUdpDestIP2: TLabel;
    edtDest2IP1: TEdit;
    edtDest2IP2: TEdit;
    edtDest2IP3: TEdit;
    edtDest2IP4: TEdit;
    lblUdpDestPort2: TLabel;
    edtUdpDest2: TEdit;
    cbUdpDest2Use: TComboBox;
    lblUdpDestUse2: TLabel;
    GBUdpIn1: TGroupBox;
    lblUdpListen1: TLabel;
    edtUdpListen1: TEdit;
    cbUdpListen1Use: TComboBox;
    lblUdpListenUse1: TLabel;
    GBUdpIn2: TGroupBox;
    lblUdpListen2: TLabel;
    edtUdpListen2: TEdit;
    lblUdpListenUse2: TLabel;
    cbUdpListen2Use: TComboBox;
    BitBtnStaticIpDefaults: TBitBtn;
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Connect2Click(Sender: TObject);
    procedure EdtSendStrKeyPress(Sender: TObject; var Key: Char);
    procedure BtnClearClick(Sender: TObject);
    procedure CbStxEtxClick(Sender: TObject);
    procedure BtnSendClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PgCMainChange(Sender: TObject);
    procedure BtnStartClick(Sender: TObject);
    procedure BtnStopClick(Sender: TObject);
    procedure PrinterSetup1Click(Sender: TObject);
    procedure ReadSettings1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ChartAfterDraw(Sender: TObject);
    procedure ChartMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WriteSettings1Click(Sender: TObject);
    procedure BtnZeroClick(Sender: TObject);
    procedure CtrlSetpointChange(Sender: TObject);
    procedure CtrlSetpointChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure TSSetpointExit(Sender: TObject);
    procedure PgCSettingsChange(Sender: TObject);
    procedure CBxSetpTypeChange(Sender: TObject);
    procedure BtnSetpClearClick(Sender: TObject);
    procedure CtrlSetpointDrawTab(Control: TCustomTabControl;
      TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure EdtFS1KeyPress(Sender: TObject; var Key: Char);
    procedure EdtFS1Exit(Sender: TObject);
    procedure EdtFilterKeyPress(Sender: TObject; var Key: Char);
    procedure EdtDelayExit(Sender: TObject);
    procedure EdtDelayKeyPress(Sender: TObject; var Key: Char);
    procedure BtnClearAllClick(Sender: TObject);
    procedure ChartZoom(Sender: TObject);
    procedure ChartUndoZoom(Sender: TObject);
    procedure BTnSpanClick(Sender: TObject);
    procedure BtnLClearClick(Sender: TObject);
    procedure BtnLSetClick(Sender: TObject);
    procedure EdtLCalWeightExit(Sender: TObject);
    procedure EdtLCalWeightKeyPress(Sender: TObject; var Key: Char);
    procedure CBxUnitsChange(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure MemoHeaderChange(Sender: TObject);
    procedure CBxDPChange(Sender: TObject);
    procedure ChartSetupClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure Index1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure TSLogShow(Sender: TObject);
    procedure TSLogHide(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnBackupCalClick(Sender: TObject);
    procedure btnRestoreCalClick(Sender: TObject);
    procedure btnCalDirectClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MemoHeaderKeyPress(Sender: TObject; var Key: Char);
    procedure ToolButton8Click(Sender: TObject);
    procedure cbEthDHCPChange(Sender: TObject);
    procedure tcSerialChange(Sender: TObject);
    procedure cbSerialChange(Sender: TObject);
    procedure MnuDeviceFinderClick(Sender: TObject);
    procedure mnuDPPointClick(Sender: TObject);
    procedure mnuDPCommaClick(Sender: TObject);
    procedure edtAddTareKeyPress(Sender: TObject; var Key: Char);
    procedure edtAddTareExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MnuOptionsClick(Sender: TObject);
    procedure edtEthHostnameExit(Sender: TObject);
    procedure ChartDblClick(Sender: TObject);
    procedure ClearChart1Click(Sender: TObject);
    procedure CkBQafEnableClick(Sender: TObject);
    procedure btnSysClockClick(Sender: TObject);
    procedure cbClkHourChange(Sender: TObject);
    procedure cbClkMinuteChange(Sender: TObject);
    procedure cbClkSecondChange(Sender: TObject);
    procedure cbClkYearChange(Sender: TObject);
    procedure cbClkMonthChange(Sender: TObject);
    procedure cbClkDayChange(Sender: TObject);
    procedure CBxWeighModeChange(Sender: TObject);
    procedure EdtConversionFactorKeyPress(Sender: TObject; var Key: Char);
    procedure EdtConversionFactorExit(Sender: TObject);
    procedure CBSerialAutoTypeChange(Sender: TObject);
    procedure BitBtnStaticIpDefaultsClick(Sender: TObject);

  private
    { Private declarations }
    FIOInterface : TIOIface;
    
    MsgBuffer : string;
    CompleteMsgBuffer : string;
    query_type: integer;
    comms_timeout: integer;
    calibrating: boolean;
    display_units: integer;

    Parser5100: TcommsObj;
    dbase, dbase_backup: Tdata5100;
    comms_mode: TCommsMode;
    dbase_changed: boolean;
    setp_changed: boolean;

    unit_info_saved: boolean;

    dbase_to_dialog_running: boolean;

// Chart vars
    OldX1,OldY1:Longint;
    OldX2,OldY2:Longint;
    csrX1,csrY1,csrX2,csrY2: double;

    page_size: double;

    divider: integer;

    // Logging variables
    FSupportsCof12 : Boolean;
    FLoggingMode : TLoggingMode;
    FLoggingRate : Integer;
    FLoggingDigitals: Array[0..NUM_DIGITAL_LOG_SERIES - 1] of TLoggingInfo;
    FLoggingStartTime : TDateTime;
    FLoggingNextSampleTime : TDateTime;
    logPanning : boolean;
    logOldTime : double;

    delay_timer: integer;
    sec_timer: integer;

    last_cmd: string;

    CommsTimeout : Integer;
    waiting_for_callback: boolean;
    callback: Tcallback;
    callback_reply: string;
    callback_timer: integer;
    callback_params: array[0..10] of integer;

    cur_unit: integer;

    closing : boolean;

    inhibitMSV : boolean;

    lcdMain : TKenMimicDisp;
    lcdCal : TKenMimicDisp;

    timeChanged : boolean;

    statusMonitor : boolean;

    timeMsgSent : TDateTime;
    timeMsgReceived : TDateTime;

    MyPollStatusThread : TPollStatusThread; // thread for polling indicator 
    MyPollStatusThreadActive : boolean; // used to test if the thread is active

    procedure dbase_to_dialog(dpchange : Boolean);
    procedure dbase_to_plist(list: Tstringlist);
    procedure dialog_to_dbase;
    procedure update_status;
    procedure dialog_to_setp(setp: integer);
    procedure setp_to_dialog(setp: integer);

    procedure slist_to_log(const list: TStringList);
    procedure log_to_slist(list: TStringList);

    procedure set_setp_enabled;

    procedure AddStr(s: string);
    procedure LoggingCalculateNextSampleTime(CurrentTime : TDateTime);
    procedure ProcessMsg(s: string);
    procedure MimicClick(Sender: TObject; btnIndex : integer; msDown : integer);
    procedure SetupChart(full: Boolean);

    // Delay for cnt * 10 milliseconds (ie 100 = 1 second delay)
    procedure my_delay(cnt: integer);
    procedure lock_page;
    procedure unlock_page;

    function read_cal_settings(list: Tstringlist): boolean;
    procedure version_check(const indicator_version : String);
    procedure activate_unit;
    procedure check_dbase_changed;
    procedure fit_chart;

    procedure FixGraph;

    procedure SetAllLCDSegs(on : Boolean);

    // Set all comms variables to some kind of sane state
    procedure InitialiseCommsVariables();
    procedure EnableWhenConnected( Connected : Boolean );
    procedure FIOInterfaceReceive( const Str : String );
    procedure FIOInterfaceConnect( Sender: TObject );
    procedure FIOInterfaceDisconnect( Sender: TObject );

    procedure ConnectDisconnect;

    procedure PopulateDecimalPointDialog(dpchar : Char);
    procedure UpdateDecimalPointCharChange;
    procedure UpdateDialogDecimalPoints;

    procedure EditOptions;

    procedure GetCalibrationFromIndicator(strs : TStrings);
    procedure SendCalibrationToIndicator(const bcastrs : TStrings);
    procedure GetViewerVersionInfo(var viewversion : String; var viewproduct : String);
    procedure GetViewerVersionTriplet(var view_vers_major, view_vers_minor, view_vers_release : String);
    function CalcCalibrationChecksum(const s : String) : Integer;
    procedure BackupCalibration(const filename : String);
    function RestoreCalibration(const filename : String) : Boolean;
    procedure UpdateLinearisationListBox(units : Integer);

    procedure ShowCalibrationError(err : Integer);
    procedure PromptSaveCalibration;
    procedure SetupForCalibration;
    procedure TeardownAfterCalibration;
    procedure WaitForCalibrationComplete(const cmd: String);
    procedure SetupSeriesTitles;
    procedure SetupUnitForLogging;
    procedure LoggingButtonsEnable;
    procedure SystemTimeToComboBoxes(hh, mn, ss, yy, mm, dd : word );
    procedure CkBEnableToComboBoxes;
    procedure CBxWeightModeToRes;
    procedure TcSerialIndexToUseItems;
    procedure TcSerialIndexToComboBoxes;
    function TcSerialIndexToTBDXPort : TBDXPort;
    procedure EthSetIpDefaults;
    procedure EthEnableDisableStaticBasedOnDHCPSetting;
  public
    { Public declarations }
    procedure SendStr(s_to_send: string; useStxEtx: boolean);
    function SendStr_callback_timeout(s_to_send: string; useStxEtx: boolean; reply: string; call_f: Tcallback; timeout : Integer): boolean;
    function SendStr_callback(s_to_send: string; useStxEtx: boolean; reply: string; call_f: Tcallback): boolean;
    procedure pollStatus();
    procedure waitForResponse();
    procedure endWaiting();
  end;

  function GetSelStr(addr : Integer) : String;

const
  clYellowGreen = TColor($00FFD0);
  LongPressMs = 2000; //ms
  NumBCASettings = 5;

var
  FrmMain: TFrmMain;

implementation
{$R *.DFM}

uses
  ComDialog, iniFiles, trafficdlg, tools, about,
  printers, ChartSetup, passcode, dmViewer, NetDevices,
  option;

const
   DLE = Chr(16);
   STX = Chr(2);
   ETX = Chr(3);
   CR  = Chr(13);
   LF  = Chr(10);
   MAXLINES = 500;

//* Send FPL at >=10Hz by sending the command and monitoring a boolean flag
// indicating a response has been received
procedure TFRMMain.pollStatus();
var
  msBetween : integer;
  msDifference : integer;

begin
  // check FIOinterface connected
  if (FIOInterface.Connected) then
  begin
    // indicator visible so poll for the status
    while (comms_mode = CMCal) or (comms_mode = CmMimic) do
    begin
      if (not calibrating) and (not waiting_for_callback) and (not inhibitMSV) then
      begin
        SendStr('FPL?;', FALSE);
        timeMsgSent := Now;
        waitForResponse();
        timeMsgReceived := Now;
        msBetween:= Round(1000 * SecsPerDay * (timeMsgReceived - timeMsgSent));
        // ensure the polling rate is no faster than 10Hz
        msDifference := 100-msBetween;
        if (msDifference > 0) then
          sleep(msDifference);
      end;
    end;

    // logging window visible so poll for weight only
    while (comms_mode = CMlogging) do
    begin
      if (FLoggingMode = lmMSVPoll) and (not inhibitMSV) then
      begin
        SendStr(GetSelStr(cur_unit) + 'MSV?;', False);
        waitForResponse();
//        sleep(100);
      end;
    end;
  end;
end;

procedure TFRMMain.waitForResponse();
var
  count : Integer;

begin
  count := 0;
  statusMonitor := true;
  while (statusMonitor) do
  begin
    count := count + 1;
    sleep(10);
    // if no response is received within the space of (CommsTimeout*10)ms then stop waiting and reset the statusMonitor boolean
    if (count >= (CommsTimeout)) then
      statusMonitor := false;
  end;
end;

procedure TFRMMain.endWaiting();
begin
  statusMonitor := false;
end;

procedure handle_ok_silent(reply: String);
begin
  if reply = '0' then
    FrmMain.waiting_for_callback := False
  else if reply = '?' then
  begin
    Frmmain.callback_timer := 0;
    FrmMain.waiting_for_callback := False;
  end;
end;   

procedure TPollStatusThread.Execute;
begin
  // poll the indicator on a separate thread
  FreeOnTerminate := true; // thread destroys itself when finished execution
  FrmMain.pollStatus();
  Frmmain.MyPollStatusThreadActive := false; // flag that the thread instance is no longer needed
  Free(); // conditions for polling no longer met so terminate thread
end;

procedure handle_ok(reply: String);
begin
  handle_ok_silent(reply);
  if reply = '?' then
    MessageDlg('Invalid Setting', mtError, [mbOK], 0);
end;

procedure handle_Q(reply: string);
var
   sig, tmp: integer;
begin
  with FrmMain do begin
    with Parser5100 do begin
      reply := callback_reply + reply;
      ParseStr(reply,false,true);
      if getintparam(0,sig,tmp,999999,-99999) then begin
        callback_params[0] := sig;
        waiting_for_callback := false;
      end;
    end;
  end;
end;

procedure handle_cal_reply(reply: string);
var
  sig, tmp: integer;
begin
  reply := FrmMain.callback_reply + reply;
  FrmMain.Parser5100.ParseStr(reply, False, True);
  if FrmMain.Parser5100.getIntParam(1, sig, tmp, 999999, -99999) then
  begin
    FrmMain.callback_params[1] := sig;
    FrmMain.waiting_for_callback := False;
  end;
end;

procedure handle_WFP(reply: string);
var
  vPort, dp: integer;
begin
  reply := FrmMain.callback_reply + reply;
  FrmMain.Parser5100.ParseStr(reply, False, True);
  if FrmMain.Parser5100.getintparam(0, vPort, dp, 9999, 0) then
  begin
    FrmMain.dbase.CurrentViewerPort := vPort;
    FrmMain.callback_params[0] := vPort;
    FrmMain.waiting_for_callback := False;
  end;
end;

procedure handle_IDN(reply: String);
var dbase : Tdata5100;
    sl : TStringList;
begin
  reply := FrmMain.callback_reply + reply;

  dbase := Tdata5100.Create();
  try
    sl := TStringList.Create();
    try
      sl.Add(reply);
      dbase.slist_to_dbase(sl);
      // FrmMain.dbase.id := dbase.id; Don't copy over ID, since this is a database setting
      FrmMain.dbase.serial := dbase.serial;
      FrmMain.dbase.version := dbase.version;
      FrmMain.dbase.model := dbase.model;
      FrmMain.dbase.model_subtype := dbase.model_subtype;
      FrmMain.waiting_for_callback := False;
    finally
      sl.Free();
    end
  finally
    dbase.Free();
  end;
end;

procedure handle_LICQ(reply: string);
var
  i,j,k,tmp :integer;
begin
  i := 0;
  with FrmMain do
  begin
    with Parser5100 do
    begin
      reply := callback_reply + reply;
      ParseStr(reply,false,true);
      if getintparam(0, i, tmp, NUM_LIN_PTS, 1) then
      begin
        dec(i);
        if getintParam(1, j, tmp, 150, -150) then
        begin
          if getintParam(2, k, tmp, 999999, -99999) then
          begin
            dbase.lin_pc[i] := j;
            dbase.lin_cor[i] := k;
            dbase_to_dialog(False);
            waiting_for_callback := false;
          end;
        end;
      end;
    end;
  end;
end;

function GetIncr(range : double) : double;
var exp : integer;
begin
  exp := 0;
  while range > 10 do begin
    range := range / 10;
    exp := exp + 1;
  end;
  while range <= 1 do begin
    range := range * 10;
    exp := exp - 1;
  end;

  if range >= 8 then range := 1
  else begin
    if range >= 4 then range := 0.5
    else begin
      if range >= 1.6 then range := 0.2
      else range := 0.1;
    end;
  end;

  while exp > 0 do begin
    range := range * 10;
    exp := exp - 1;
  end;
  while exp < 0 do begin
    range := range / 10;
    exp := exp + 1;
  end;

  result := range;
end;

procedure TFrmMain.SetupChart(full: Boolean);
var incr: Double;
    dp_divider : Integer;
    dio_scaling : Double;
    i : Integer;
begin
   if (full) then
   begin
     dp_divider := floor(intpower(10, dbase.dp_pos));
     divider := dp_divider;
     if dbase.hi_res then
       divider := divider * 10;
     if ((dbase.weighing_mode > 0) and (dbase.weighing_mode < 3)) then
       Chart.LeftAxis.Maximum := dbase.fs2 / dp_divider
     else
       Chart.LeftAxis.Maximum := dbase.fs1 / dp_divider;
     Chart.LeftAxis.Minimum := -Chart.LeftAxis.Maximum;
     Chart.LeftAxis.Title.Caption := Format('Weight (%s)', [CbxUnits.Items.Strings[dbase.units]]);

     FLoggingRate := FrmLogDialog.GetLoggingRate();
     LoggingCalculateNextSampleTime(Now);

     for i := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
       FLoggingDigitals[i].SetLogType(FrmLogDialog.GetLoggingType(i));

     if FLoggingRate = 0 then
        incr := 1.0 / dbase.filter
     else
        incr := FLoggingRate / 1000;

     chart.bottomaxis.Minimum := 0;
     if incr < 0.1 then
       chart.bottomaxis.maximum := 10.0
     else
       chart.bottomaxis.maximum := 100 * incr;
     page_size := chart.bottomaxis.maximum / 2;
   end;

   Chart.BottomAxis.Increment := GetIncr(Chart.BottomAxis.Maximum - Chart.BottomAxis.Minimum); //incr;

   // Scale digital IOs so they fit
   dio_scaling := (Chart.LeftAxis.Maximum - Chart.LeftAxis.Minimum) / 30;
   Series2.YValues.Multiplier := dio_scaling;
   Series3.YValues.Multiplier := dio_scaling;
   Series4.YValues.Multiplier := dio_scaling;
   Series5.YValues.Multiplier := dio_scaling;
   Series6.YValues.Multiplier := dio_scaling;
   Series7.YValues.Multiplier := dio_scaling;
   Series8.YValues.Multiplier := dio_scaling;
   Series9.YValues.Multiplier := dio_scaling;
end;

procedure TFrmMain.dbase_to_dialog(dpchange : Boolean);
var
  i: integer;
  boolAnlAbs, boolAnlClip, boolQafEnable, boolSenseLine : boolean;

begin
  if not dbase_to_dialog_running then
  begin
    dbase_to_dialog_running := True;

    if (not dpchange) then
    begin
      update_status();
      CBxDP.itemindex := dbase.dp_pos;
      CBxWeighMode.itemindex := dbase.weighing_mode;
      CBxUnits.itemindex := dbase.units;

      // Force units lables to update
      Self.CBxUnitsChange(Self);

      CkBHires.checked := dbase.hi_res;

      edtCalDirectZero.text := floattostrf(dbase.directZero/10000,ffFixed,10,4);
      edtCalDirectSpan.text := floattostrf(dbase.directSpan/10000,ffFixed,10,4);

      CBxRes1.ItemIndex := dbase.res1;
      CBxRes2.ItemIndex := dbase.res2;
      cbxFilter.ItemIndex := 6;
      for i := 0 to cbxFilter.Items.Count-1 do
      begin
        if cbxFilter.Items.Strings[i] = inttostr(dbase.filter) then
        begin
          cbxFilter.ItemIndex := i;
          break;
        end;
      end;
      //cbxFilter.text := format('%d',[dbase.filter]);

      CBxMode.itemindex := dbase.trade_mode;
      CBxAvSetting.itemindex := dbase.av_setting;
      CBxJitter.ItemIndex := dbase.jitter;
      CBxMotion.itemindex := dbase.motion;
      CBxZtrac.itemindex := dbase.ztrac;
      CBxZrange.itemindex := dbase.zrange;
      CBxAZero.itemindex := dbase.zstartup;

      CBxZbut.itemindex := dbase.z_but;
      CBxTbut.itemindex := dbase.t_but;
      CBxGbut.itemindex := dbase.g_but;
      cbF1Enable.ItemIndex := dbase.f_but[1];
      cbF2Enable.ItemIndex := dbase.f_but[2];
      cbF3Enable.ItemIndex := dbase.f_but[3];

      cbFunction1.ItemIndex := dbase.front_func[1];
      cbFunction2.ItemIndex := dbase.front_func[2];
      cbFunction3.ItemIndex := dbase.front_func[3];

      CBxRem1.itemindex := dbase.rem[1];
      CBxRem2.itemindex := dbase.rem[2];
      CBxRem3.itemindex := dbase.rem[3];
      CBxRem4.itemindex := dbase.rem[4];
      CBxRem5.itemindex := dbase.rem[5];
      CBxRem6.itemindex := dbase.rem[6];
      CBxRem7.itemindex := dbase.rem[7];
      CBxRem8.itemindex := dbase.rem[8];

      EdtID.Text := dbase.id;
      cbAddress.ItemIndex := dbase.netAddress;
      CBxPMode.itemindex := dbase.pr_mode;
      EDtRows.text := format('%d',[dbase.tic_row]);
      EDtCols.text := format('%d',[dbase.tic_col]);
      MemoHeader.lines.Clear();
      for i := 0 to NUM_HEADER_LINES-1 do
        MemoHeader.Lines.Add(dbase.prhdr[i]);
      EdtPFmt.text := dbase.pr_fmt;

      CBxAType.itemindex := dbase.auto_type;
      CBxASrc.itemindex := dbase.auto_src;
      CBPrintInterlock.ItemIndex := dbase.print_interlock;
      EdtAFmt.text := dbase.au_fmt;
      edtAutoStartChar.Text := Format('%d', [dbase.auto_start_char]);
      edtAutoEndChar1.Text := Format('%d', [dbase.auto_end_char1]);
      edtAutoEndChar2.Text := Format('%d', [dbase.auto_end_char2]);

      // Setup ethernet settings page
      cbEthDHCP.ItemIndex := ord(dbase.ethDHCPEn);
      edtEthAddr1.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethAddr,   0,'.');
      edtEthAddr2.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethAddr,   1,'.');
      edtEthAddr3.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethAddr,   2,'.');
      edtEthAddr4.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethAddr,   3,'.');
      edtEthMask1.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethMask,   0,'.');
      edtEthMask2.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethMask,   1,'.');
      edtEthMask3.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethMask,   2,'.');
      edtEthMask4.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethMask,   3,'.');
      edtEthGW1.Text   := dbase.Ethernet_GetFieldFromStr(dbase.ethGateway,0,'.');
      edtEthGW2.Text   := dbase.Ethernet_GetFieldFromStr(dbase.ethGateway,1,'.');
      edtEthGW3.Text   := dbase.Ethernet_GetFieldFromStr(dbase.ethGateway,2,'.');
      edtEthGW4.Text   := dbase.Ethernet_GetFieldFromStr(dbase.ethGateway,3,'.');
      edtEthDns1Octet1.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS1, 0,'.');
      edtEthDns1Octet2.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS1, 1,'.');
      edtEthDns1Octet3.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS1, 2,'.');
      edtEthDns1Octet4.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS1, 3,'.');
      edtEthDns2Octet1.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS2, 0,'.');
      edtEthDns2Octet2.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS2, 1,'.');
      edtEthDns2Octet3.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS2, 2,'.');
      edtEthDns2Octet4.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS2, 3,'.');
      edtEthDns3Octet1.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS3, 0,'.');
      edtEthDns3Octet2.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS3, 1,'.');
      edtEthDns3Octet3.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS3, 2,'.');
      edtEthDns3Octet4.Text := dbase.Ethernet_GetFieldFromStr(dbase.ethDNS3, 3,'.');
      edtEthMAC1.Text  := dbase.Ethernet_GetFieldFromStr(dbase.ethMac,    0,':');
      edtEthMAC2.Text  := dbase.Ethernet_GetFieldFromStr(dbase.ethMac,    1,':');
      edtEthMAC3.Text  := dbase.Ethernet_GetFieldFromStr(dbase.ethMac,    2,':');
      edtEthMAC4.Text  := dbase.Ethernet_GetFieldFromStr(dbase.ethMac,    3,':');
      edtEthMAC5.Text  := dbase.Ethernet_GetFieldFromStr(dbase.ethMac,    4,':');
      edtEthMAC6.Text  := dbase.Ethernet_GetFieldFromStr(dbase.ethMac,    5,':');
      edtEthHostname.Text := dbase.ethHostname;
      edtEthSearchDomain.Text := dbase.ethSearchDomain;
      self.EthEnableDisableStaticBasedOnDHCPSetting();

      tcSerial.Tabs.Clear();
      tcSerial.Tabs.Add('SER.M.1A (Module 1A)');
      tcSerial.Tabs.Add('SER.M.1B (Module 1B)');
      tcSerial.Tabs.Add('SER.M.2A (Module 2A)');
      tcSerial.Tabs.Add('SER.M.2B (Module 2B)');
      tcSerial.Tabs.Add('SER.SLV (USB Slave)');
      tcSerial.Tabs.Add('SER.HST (USB Host)');
      if (indicator_model_subtype_has_db9_serial(dbase.model_subtype)) then
      begin
        tcSerial.Tabs.Add('SER.1 (Serial 1)');
        tcSerial.Tabs.Add('SER.2 (Serial 2)');
      end;
      tcSerialChange(self); // update tcSerial
      
      edtSerialNetPort.text := IntToStr(dbase.portData14[BDXTcpNet].tcpPort);
      edtSerialNetTimeout.text := IntToStr(dbase.portData14[BDXTcpNet].tcpTimeout);

      CBSerialAutoType.ItemIndex := dbase.portData14[BDXTcpAuto].use;
      edtSerialAutoPort.text := IntToStr(dbase.portData14[BDXTcpAuto].tcpPort);
      edtSerialAutoTimeout.text := IntToStr(dbase.portData14[BDXTcpAuto].tcpTimeout);

      edtUdpDest1.text := IntToStr(dbase.portData14[BDXUdpO1].tcpPort);
      edtDest1IP1.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO1].udpDestIP,0,'.');
      edtDest1IP2.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO1].udpDestIP,1,'.');
      edtDest1IP3.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO1].udpDestIP,2,'.');
      edtDest1IP4.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO1].udpDestIP,3,'.');
      cbUdpDest1Use.ItemIndex := dbase.portData14[BDXUdpO1].use;

      edtUdpDest2.text := IntToStr(dbase.portData14[BDXUdpO2].tcpPort);
      edtDest2IP1.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO2].udpDestIP,0,'.');
      edtDest2IP2.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO2].udpDestIP,1,'.');
      edtDest2IP3.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO2].udpDestIP,2,'.');
      edtDest2IP4.text := dbase.Ethernet_GetFieldFromStr(dbase.portData14[BDXUdpO2].udpDestIP,3,'.');
      cbUdpDest2Use.ItemIndex := dbase.portData14[BDXUdpO2].use;

      edtUdpListen1.text := IntToStr(dbase.portData14[BDXUdpI1].tcpPort);
      cbUdpListen1Use.ItemIndex := dbase.portData14[BDXUdpI1].use;
      edtUdpListen1.text := IntToStr(dbase.portData14[BDXUdpI1].tcpPort);
      cbUdpListen2Use.ItemIndex := dbase.portData14[BDXUdpI2].use;

      cbBuzEn.ItemIndex := ord(dbase.buzEn);

      cbMbEndian.ItemIndex := dbase.mbEndian;
      edtMbPort.Text := format('%d', [dbase.mbPort]);

      cbAnlType.ItemIndex := dbase.anlType;
      cbAnlSource.ItemIndex := dbase.anlSource;
      EdtAnlZero.Text := format('%d', [dbase.anlZero]);
      EdtAnlSpan.Text := format('%d', [dbase.anlSpan]);

      if (dbase.anlAbs = 1) then boolAnlAbs := TRUE else boolAnlAbs := FALSE;
      if (dbase.anlClip = 1) then boolAnlClip := TRUE else boolAnlClip := FALSE;

      CkBAbsolute.checked := boolAnlAbs;
      CkBClip.checked := boolAnlClip;   

      cbClkHour.ItemIndex := dbase.clkHour;
      cbClkMinute.ItemIndex := dbase.clkMinute;
      cbClkSecond.ItemIndex := dbase.clkSecond;
      cbClkYear.ItemIndex := dbase.clkYear;
      cbClkMonth.ItemIndex := (dbase.clkMonth)-1;
      cbClkDay.ItemIndex := (dbase.clkDay)-1;
      CBTimeFormat.ItemIndex := dbase.time_format;
      CBDateFormat.ItemIndex := dbase.date_format;

      if (dbase.qafEnable = 1) then boolQafEnable := TRUE else boolQafEnable := FALSE;
      CkBQafEnable.checked := boolQafEnable;
      Self.CkBEnableToComboBoxes();
      cbQafDay.ItemIndex := (dbase.qafDay)-1;
      cbQafMonth.ItemIndex := (dbase.qafMonth)-1;
      cbQafYear.ItemIndex := dbase.qafYear;
      cbBrightness.ItemIndex := dbase.brightness;
      CBSecondaryUnits.ItemIndex := dbase.secondary_units;
      CBTertiaryUnits.ItemIndex := dbase.tertiary_units;
      EdtConversionFactor.Text := fmt_int(dbase.conversion_factor, 3, datViewer.DecimalPointChar);
      CBShowLbOz.ItemIndex := dbase.show_lboz;

      if (dbase.senseLine = 1) then boolSenseLine := TRUE else boolSenseLine := FALSE;
      CkBSenseLine.Checked := boolSenseLine;

//      ChkSetpShow.checked := (dbase.setp_display = 1);
//      ChkAutoStart.checked := (dbase.setp_auto_start = 1);
//      ChkErrorPause.checked := (dbase.setp_error = 1);
//      ChkDelayFill.checked := (dbase.setp_delay = 1);
//      ChkFeeder.checked := (dbase.setp_feeder = 1);

//      EdtInflight.text := format('%d',[dbase.flt_adj]);
    end;

    // These ones are always updated
    edtAddTare.text := fmt_int(dbase.addTare, dbase.dp_pos, datViewer.DecimalPointChar);
    EdtFS1.Text := fmt_int(dbase.fs1, dbase.dp_pos, datViewer.DecimalPointChar);
    EdtFS2.Text := fmt_int(dbase.fs2, dbase.dp_pos, datViewer.DecimalPointChar);
    EdtZband.text := fmt_int(dbase.zband, dbase.dp_pos, datViewer.DecimalPointChar);

    Self.CBxWeightModeToRes();
    UpdateLinearisationListBox(dbase.units);
    EdtCalWeight.Text := fmt_int(dbase.cal_weight, dbase.dp_pos, datViewer.DecimalPointChar);

    EdtSetpJogOn.Text := fmt_int(dbase.setp_opt_jog_on, 0, datViewer.DecimalPointChar);
    EdtSetpJogOff.Text := fmt_int(dbase.setp_opt_jog_off, 0, datViewer.DecimalPointChar);
    EdtSetpOptJogSet.Text := fmt_int(dbase.setp_opt_jogs_in_set, 0, datViewer.DecimalPointChar);
    EdtSetpOptMaxJogSets.Text := fmt_int(dbase.setp_opt_max_jog_sets, 0, datViewer.DecimalPointChar);
    CBSetpOptFeederType.ItemIndex := dbase.setp_opt_feeder_type;
    EdtSetpOptDelayCheck.Text := fmt_int(dbase.setp_opt_delay_check, 0, datViewer.DecimalPointChar);

    dbase_changed := True;
    dbase_to_dialog_running := False;
  end;
end;

var
  res_opt: array[0..6] of integer = (1,2,5,10,20,50,100);

procedure TFrmMain.dbase_to_plist(list: Tstringlist);
var
  i : Integer;
  s : String;
  bdx : TBDXPort;

  procedure dbase_serial_to_plist(list: TStringList; const portname : String; const serialport : TComPortStandard);
  begin
    list.add(Format('  Serial %s: %s, %s, %s, %s, %s, %s, %s, %s',
                    [portname,
                     cbSerialUse.items.strings[serialport.use],
                     cbbaud.items.strings[serialport.baud],
                     cbparity.items.strings[serialport.parity],
                     cbdatabits.items.strings[serialport.databits],
                     cbstopbits.items.strings[serialport.stopbits],
                     cbtermen.items.strings[serialport.termen],
                     cbdtren.items.strings[serialport.dtren],
                     cbHardware.items.strings[serialport.rs232En]]));
  end;

begin
  list.clear();
  list.add(format('C500 SN:%s Version %s ID: %s',[dbase.serial,dbase.version,dbase.id]));
  list.add(format('Address = %d',[dbase.netAddress]));

  list.add('');
  list.add(' --- BUILD ---');
  list.add(format('  Weighing Mode: %s', [CbxWeighMode.items[dbase.weighing_mode]]));
  list.add(format('  Units: %s', [CbxUnits.items[dbase.units]]));
  list.add(format('  Max1 = %s, e1 = %s', [fmt_int(dbase.fs1, dbase.dp_pos, datViewer.DecimalPointChar), fmt_int(res_opt[dbase.res1], dbase.dp_pos, datViewer.DecimalPointChar)]));
  if (dbase.weighing_mode = 1 ) or (dbase.weighing_mode = 2) then
     list.add(format('  Max2 = %s, e2 = %s', [fmt_int(dbase.fs1, dbase.dp_pos, datViewer.DecimalPointChar), fmt_int(res_opt[dbase.res1], dbase.dp_pos, datViewer.DecimalPointChar)]));
  if dbase.hi_res then s := 'on' else s := 'off';
  list.add(format('  High Resolution: %s', [s]));
  list.add(format('  Additive Tare Maximum: %s', [fmt_int(dbase.addTare, dbase.dp_pos, datViewer.DecimalPointChar)]));
  list.add(format('  Direct Cal mV/V Zero: %s', [edtCalDirectZero.text]));
  list.add(format('  Direct Cal mV/V Fullscale: %s', [edtCalDirectSpan.text]));
  list.add(format('  Synch Frequency: %d Hz', [dbase.filter]));
  list.add(format('  Sense Line: %d', [dbase.senseLine]));  

  list.add('');
  list.add(' --- OPTION ---');
  list.add(format('  Operating Mode: %s',[cBxMode.items[dbase.trade_mode]]));

  list.add(format('  Average: %s readings, Jitter: %s',[CbxAvSetting.items[dbase.av_setting],
                                             CbxJitter.items[dbase.jitter]]));
  list.add(format('  Motion: %s',[CbxMotion.items[dbase.motion]]));
  list.add(format('  Zero Tracking: %s, Zero Range: %s, Auto Zero: %s, Zero Band: %s',
                  [CbxZTrac.items[dbase.ztrac],
                   CbxZRange.items[dbase.zrange],
                   CbxAZero.items[dbase.zstartup],
                   fmt_int(dbase.zband, dbase.dp_pos, datViewer.DecimalPointChar)]));

  list.add('');
  list.add(' --- SPECIAL ---');
  list.add(format('  Buzzer enable: %s', [cbBuzEn.text]));
  list.add(format('  Brightness: %d', [dbase.brightness]));  
  list.add(format('  Zero key: %s, Tare key: %s, Gross/Net key: %s, F1 key: %s, F2 key: %s, F3 key: %s',
              [CbxZbut.items[dbase.z_but],CbxTbut.items[dbase.t_but],
               CbxGbut.items[dbase.g_but],
               cbF1Enable.Items[dbase.f_but[1]],
               cbF2Enable.Items[dbase.f_but[2]],
               cbF3Enable.Items[dbase.f_but[3]]
              ]));

  list.add(Format('  Function 1: %s, Function 2: %s, Function 3: %s',
                  [ cbFunction1.Items[dbase.front_func[1]],
                    cbFunction2.Items[dbase.front_func[2]],
                    cbFunction3.Items[dbase.front_func[3]]
                  ]));

  list.add(format('  Rem 1: %s, Rem 2: %s, Rem 3: %s Rem 4: %s Rem 5: %s Rem 6: %s Rem 7: %s Rem 8: %s',
               [ CbxRem1.items[dbase.rem[1]], CbxRem2.items[dbase.rem[2]],
                 CbxRem3.items[dbase.rem[3]], CbxRem4.items[dbase.rem[4]],
                 CbxRem5.items[dbase.rem[5]], CbxRem6.items[dbase.rem[6]],
                 CbxRem7.items[dbase.rem[7]], CbxRem8.items[dbase.rem[8]]
               ]));
  list.add(format('  Secondary Units: %s', [CBSecondaryUnits.Items[dbase.secondary_units]]));
  list.add(format('  Tertiary Units: %s', [CBTertiaryUnits.Items[dbase.tertiary_units]]));
  list.add(format('  Conversion Factor: %s', [fmt_int(dbase.conversion_factor, 3, datViewer.DecimalPointChar)]));
  list.add(format('  Show LB:OZ: %s', [CBShowLbOz.Items[dbase.show_lboz]]));

  list.add('');

  list.add(' --- ETHERNET ---');
  list.add(format('  DHCP: %s',        [cbEthDHCP.text]));
  list.add(format('  Address: %s',     [dbase.ethAddr]));
  list.add(format('  Mask: %s',        [dbase.ethMask]));
  list.add(format('  Gateway: %s',     [dbase.ethGateway]));
  list.add(format('  DNS 1: %s',       [dbase.ethDNS1]));
  list.add(format('  DNS 2: %s',       [dbase.ethDns2]));
  list.add(format('  DNS 3: %s',       [dbase.ethDns3]));
  list.add(format('  MAC Address: %s', [dbase.ethMac]));
  list.add(format('  Hostname: %s',    [dbase.ethHostname]));
  list.add(format('  Search Domain: %s', [dbase.ethSearchDomain]));
  list.add('');

  list.add(' --- SERIAL ---');
  for bdx := Low(TBDXPort) to High(TBDXPort) do
  begin
    case bdx of
      BDXUnused1, BDXUnused2, BDXUnused3, BDXUnused4:
        ;
      BDXTcpNet:
        list.add(Format('  Serial %s: Port: %d Timeout: %d', [ BDXPortNames[bdx], dbase.portData14[bdx].tcpPort, dbase.portData14[bdx].tcpTimeout ]));
      BDXTcpAuto:
        list.add(Format('  Serial %s: Type: %s Port: %d Timeout: %d', [ BDXPortNames[bdx], cbSerialUse.items.strings[dbase.portData14[bdx].use], dbase.portData14[bdx].tcpPort, dbase.portData14[bdx].tcpTimeout ]));
      BDXUdpI1, BDXUdpI2:
        list.add(Format('  Serial %s: Type: %s Port: %d', [ BDXPortNames[bdx], cbSerialUse.items.strings[dbase.portData14[bdx].use], dbase.portData14[bdx].tcpPort ]));
      BDXUdpO1, BDXUdpO2:
        list.add(Format('  Serial %s: Type: %s UDP Destination: %s:%d', [ BDXPortNames[bdx], cbSerialUse.items.strings[dbase.portData14[bdx].use], dbase.portData14[bdx].udpDestIP, dbase.portData14[bdx].tcpPort ]));
      BDXSerial1, BDXSerial2:
        if indicator_model_subtype_has_db9_serial(dbase.model_subtype) then
        begin
          dbase_serial_to_plist(list, BDXPortNames[bdx], dbase.portData14[bdx]);
        end;
      else
        dbase_serial_to_plist(list, BDXPortNames[bdx], dbase.portData14[bdx]);
      end;
  end;
  list.add('  Printing');
  list.add(format('        Mode: %s',[CBxPMode.items[dbase.pr_mode]]));
  list.add(format('       Space: Rows: %d, Columns: %d',[dbase.tic_row,dbase.tic_col]));
  list.add(format('      Header: %s',[dbase.prhdr[0]]));
  for i := 1 to NUM_HEADER_LINES-1 do
    list.add(format('             %s',[dbase.prhdr[i]]));
  list.add(format('      Format: %s',[dbase.pr_fmt]));
  list.add(format('      I.Lock: %s', [CBPrintInterlock.Items[dbase.print_interlock]]));
  list.add('  Auto Output');
  list.add(format('       Type: %s,  Source: %s',[CBxAType.items[dbase.auto_type],CBxASrc.items[dbase.auto_src]]));
  list.add(format('     Format: %s',[dbase.au_fmt]));
  list.add(format('     Start Char: %d', [dbase.auto_start_char]));
  list.add(format('     End Char 1: %d', [dbase.auto_end_char1]));
  list.add(format('     End Char 2: %d', [dbase.auto_end_char2]));

  list.add('  Modbus Options');
  list.add(format('  Port: %d',        [dbase.mbPort]));
  list.add(format('  Endian: %s',      [cbMbEndian.items[dbase.mbEndian]]));

  list.add('');
  list.add(' --- SETPOINT ---');

  s := '';
  for i := 0 to NUM_SETPOINTS - 1 do
  begin
    case dbase.setp_data[i].setp_type of

      SETP_TYPE_OVER, SETP_TYPE_UNDER, SETP_TYPE_WEIGHOUT, SETP_TYPE_WEIGHIN:
      begin
        list.add(format('   Setpoint %d:  %s', [i+1, CBxSetpType.items[dbase.setp_data[i].setp_type]]));
        list.add(format('       Source: %s, Logic: %s, Lock: %s, Alarm: %s, Timing: %s, Reset: %s',
                        [CBxSetpSrc.items[dbase.setp_data[i].setp_src],
                         CBxSetpLogic.items[dbase.setp_data[i].setp_logic],
                         CBxSetpLock.items[dbase.setp_data[i].setp_lock],
                         CBxSetpAlarm.items[dbase.setp_data[i].setp_alarm],
                         CBSetpTiming.items[dbase.setp_data[i].setp_timing],
                         CBSetpReset.items[dbase.setp_data[i].setp_reset]]));
        list.add(format('       Target: %s, In-flight: %s, Hysteresis: %s',
                        [fmt_int(dbase.setp_data[i].setp_target, dbase.dp_pos, datViewer.DecimalPointChar),
                         fmt_int(dbase.setp_data[i].setp_inflight, dbase.dp_pos, datViewer.DecimalPointChar),
                         fmt_int(dbase.setp_data[i].setp_hysteresis, dbase.dp_pos, datViewer.DecimalPointChar)]));
      end;

      SETP_TYPE_ON, SETP_TYPE_COZ, SETP_TYPE_ZERO, SETP_TYPE_NET, SETP_TYPE_MOTION, SETP_TYPE_ERROR, SETP_TYPE_BUZZER:
      begin
        list.add(format('   Setpoint %d:  %s',
                        [i+1, CBxSetpType.items[dbase.setp_data[i].setp_type]]));
        list.add(format('       Logic: %s, Alarm: %s, Timing: %s, Reset: %s',
                        [CBxSetpLogic.items[dbase.setp_data[i].setp_logic],
                         CBxSetpAlarm.items[dbase.setp_data[i].setp_alarm],
                         CBSetpTiming.items[dbase.setp_data[i].setp_timing],
                         CBSetpReset.items[dbase.setp_data[i].setp_reset]]));
      end;
    else // case -> else (including SETP_TYPE_OFF)
    begin
        // Don't print anything
    end; // case else begin
    end; // case -> else
  end; // for


  list.add('');
  list.add(' --- SETPOINT OPTIONS ---');
  list.add(format('  Jog On Time: %s ms',      [fmt_int(dbase.setp_opt_jog_on, 0, datViewer.DecimalPointChar)]));
  list.add(format('  Jog Off Time: %s ms',     [fmt_int(dbase.setp_opt_jog_off, 0, datViewer.DecimalPointChar)]));
  list.add(format('  Jogs In Set: %s',         [fmt_int(dbase.setp_opt_jogs_in_set, 0, datViewer.DecimalPointChar)]));
  list.add(format('  Max Jog Sets: %s',        [fmt_int(dbase.setp_opt_max_jog_sets, 0, datViewer.DecimalPointChar)]));
  list.add(format('  Feeder Type: %s',         [CBSetpOptFeederType.Items[dbase.setp_opt_feeder_type]]));
  list.add(format('  Delay Check: %s ms',      [fmt_int(dbase.setp_opt_delay_check, 0, datViewer.DecimalPointChar)]));

  list.add('');
  list.add(' --- ANALOG ---');
  list.add(format('  Type: %s',        [cbAnlType.items[dbase.anlType]]));
  list.add(format('  Source: %s',      [cbAnlSource.items[dbase.anlSource]]));
  list.add(format('  Zero: %d',        [dbase.anlZero]));
  list.add(format('  Span: %d',        [dbase.anlSpan]));
  list.add(format('  Force: %d',       [dbase.anlFrc]));
  list.add(format('  Absolute: %d',    [dbase.anlAbs]));
  list.add(format('  Clip: %d',        [dbase.anlClip]));

  list.add('');
  list.add(' --- CLOCK ---');
  list.add(format('  Hour: %d',        [dbase.clkHour]));
  list.add(format('  Minute: %d',      [dbase.clkMinute]));
  list.add(format('  Second: %d',      [dbase.clkSecond]));
  list.add(format('  Year: %d',        [dbase.clkYear]));
  list.add(format('  Month: %d',       [dbase.clkMonth]));
  list.add(format('  Day: %d',         [dbase.clkDay]));
  list.add(format('  Time Format: %s', [CBTimeFormat.Items[dbase.time_format]]));
  list.add(format('  Date Format: %s', [CBDateFormat.Items[dbase.date_format]]));

  list.add('');
  list.add(' --- MAINTENANCE ---');
  list.add(format('  Enabled: %d',     [dbase.qafEnable]));
  list.add(format('  Year: %d',        [dbase.qafYear]));
  list.add(format('  Month: %d',       [dbase.qafMonth]));
  list.add(format('  Day: %d',         [dbase.qafDay]));
end;

procedure TFrmMain.dialog_to_dbase();
var
i : integer;
intAnlAbs, intAnlClip, intQafEnable, intSenseLine : integer;

begin
  dbase.dp_pos := CBxDP.ItemIndex;
  dbase.weighing_mode := CBxWeighMode.ItemIndex;
  dbase.units := CBxUnits.ItemIndex;

  dbase.hi_res := CkBHires.Checked;
  dbase.addTare := my_strtoint(edtAddTare.Text);
  dbase.directZero := Round(StrToFloat(edtCalDirectZero.Text)*10000);
  dbase.directSpan := Round(StrToFloat(edtCalDirectSpan.Text)*10000);
  dbase.fs1 := my_strtoint(EdtFS1.Text);
  dbase.fs2 := my_strtoint(EdtFS2.Text);
  dbase.res1 := CBxRes1.ItemIndex;
  dbase.res2 := CBxRes2.ItemIndex;
  dbase.filter := Trunc(StrToFloat(cbxFilter.Text));

  dbase.trade_mode := CBxMode.ItemIndex;
  dbase.av_setting := CBxAvSetting.ItemIndex;
  dbase.jitter := CBxJitter.ItemIndex;
  dbase.motion := CBxMotion.ItemIndex;
  dbase.ztrac := CBxZtrac.ItemIndex;
  dbase.zrange := CBxZrange.ItemIndex;
  dbase.zstartup := CBxAZero.ItemIndex;
  dbase.zband := my_strtoint(EdtZband.Text);

  dbase.z_but := CBxZbut.ItemIndex;
  dbase.t_but := CBxTbut.ItemIndex;
  dbase.g_but := CBxGbut.ItemIndex;
  dbase.f_but[1] := cbF1Enable.ItemIndex;
  dbase.f_but[2] := cbF2Enable.ItemIndex;
  dbase.f_but[3] := cbF3Enable.ItemIndex;

  dbase.front_func[1] := cbFunction1.ItemIndex;
  dbase.front_func[2] := cbFunction2.ItemIndex;
  dbase.front_func[3] := cbFunction3.ItemIndex;

  dbase.rem[1] := CBxRem1.ItemIndex;
  dbase.rem[2] := CBxRem2.ItemIndex;
  dbase.rem[3] := CBxRem3.ItemIndex;
  dbase.rem[4] := CBxRem4.ItemIndex;
  dbase.rem[5] := CBxRem5.ItemIndex;
  dbase.rem[6] := CBxRem6.ItemIndex;
  dbase.rem[7] := CBxRem7.ItemIndex;
  dbase.rem[8] := CBxRem8.ItemIndex;

  dbase.id := EdtID.Text;
  dbase.netAddress := cbAddress.ItemIndex;

  dbase.ethDHCPEn  := Boolean(cbEthDHCP.ItemIndex);
  dbase.ethAddr    := dbase.Ethernet_GetStrFromFields([edtEthAddr1.Text,edtEthAddr2.Text,edtEthAddr3.Text,edtEthAddr4.Text]);
  dbase.ethMask    := dbase.Ethernet_GetStrFromFields([edtEthMask1.Text,edtEthMask2.Text,edtEthMask3.Text,edtEthMask4.Text]);
  dbase.ethGateway := dbase.Ethernet_GetStrFromFields([edtEthGW1.Text,  edtEthGW2.Text,  edtEthGW3.Text,  edtEthGW4.Text]);
  dbase.ethDNS1    := dbase.Ethernet_GetStrFromFields([edtEthDns1Octet1.Text, edtEthDns1Octet2.Text, edtEthDns1Octet3.Text, edtEthDns1Octet4.Text]);
  dbase.ethDNS2    := dbase.Ethernet_GetStrFromFields([edtEthDns2Octet1.Text, edtEthDns2Octet2.Text, edtEthDns2Octet3.Text, edtEthDns2Octet4.Text]);
  dbase.ethDNS3    := dbase.Ethernet_GetStrFromFields([edtEthDns3Octet1.Text, edtEthDns3Octet2.Text, edtEthDns3Octet3.Text, edtEthDns3Octet4.Text]);
  //dbase.ethMac     := dbase.Ethernet_GetStrFromFields([edtEthMAC1.Text, edtEthMAC2.Text, edtEthMAC3.Text, edtEthMAC4.Text, edtEthMAC5.Text, edtEthMAC6.Text]);
  dbase.ethHostname := edtEthHostname.Text;
  dbase.ethSearchDomain := edtEthSearchDomain.Text;

  dbase.portData14[BDXTcpNet].tcpPort := my_strtoint(edtSerialNetPort.Text);
  dbase.portData14[BDXTcpNet].tcpTimeout := my_strtoint(edtSerialNetTimeout.Text);

  dbase.portData14[BDXTcpAuto].use := CBSerialAutoType.ItemIndex;
  dbase.portData14[BDXTcpAuto].tcpPort := my_strtoint(edtSerialAutoPort.Text);
  dbase.portData14[BDXTcpAuto].tcpTimeout := my_strtoint(edtSerialAutoTimeout.Text);

  dbase.portData14[BDXUdpO1].tcpPort := my_strtoint(edtUdpDest1.Text);
  dbase.portData14[BDXUdpO1].udpDestIP := dbase.Ethernet_GetStrFromFields([edtDest1IP1.Text,edtDest1IP2.Text,edtDest1IP3.Text,edtDest1IP4.Text]);
  dbase.portData14[BDXUdpO1].use := cbUdpDest1Use.ItemIndex;
  dbase.portData14[BDXUdpO2].tcpPort := my_strtoint(edtUdpDest2.Text);
  dbase.portData14[BDXUdpO2].udpDestIP := dbase.Ethernet_GetStrFromFields([edtDest2IP1.Text,edtDest2IP2.Text,edtDest2IP3.Text,edtDest2IP4.Text]);
  dbase.portData14[BDXUdpO2].use := cbUdpDest2Use.ItemIndex;
  dbase.portData14[BDXUdpI1].tcpPort := my_strtoint(edtUdpListen1.Text);
  dbase.portData14[BDXUdpI1].use := cbUdpListen1Use.ItemIndex;
  dbase.portData14[BDXUdpI2].tcpPort := my_strtoint(edtUdpListen2.Text);
  dbase.portData14[BDXUdpI2].use := cbUdpListen2Use.ItemIndex;

  // don't need to write serial port settings - these are written as soon as they are changed.

  dbase.buzEn      := Boolean(cbBuzEn.ItemIndex);

  dbase.pr_mode := CBxPMode.ItemIndex;
  dbase.tic_row := StrToInt(EDtRows.Text);
  dbase.tic_col := StrToInt(EDtCols.Text);
  for i := 0 to NUM_HEADER_LINES-1 do dbase.prhdr[i] := '';
  for i := 0 to MemoHeader.lines.Count-1 do dbase.prhdr[i] := MemoHeader.lines.Strings[i];
  dbase.pr_fmt := EdtPFmt.text;
  dbase.auto_type := CBxAType.itemindex;
  dbase.auto_src := CBxASrc.itemindex;
  dbase.print_interlock := CBPrintInterlock.ItemIndex;
  dbase.au_fmt := EdtAFmt.text;
  dbase.auto_start_char := my_strtoint(edtAutoStartChar.Text);
  dbase.auto_end_char1 := my_strtoint(edtAutoEndChar1.Text);
  dbase.auto_end_char2 := my_strtoint(edtAutoEndChar2.Text);

  dbase.mbPort := my_strtoint(EdtMbPort.Text);
  dbase.mbEndian := cbMbEndian.ItemIndex;

  dbase.anlType := cbAnlType.ItemIndex;
  dbase.anlSource := cbAnlSource.ItemIndex;
  dbase.anlZero := my_strtoint(EdtAnlZero.Text);
  dbase.anlSpan := my_strtoint(EdtAnlSpan.Text);
//  dbase.anlFrc := 0;
  if (CkBAbsolute.checked = TRUE) then intAnlAbs := 1 else intAnlAbs := 0;
  if (CkBClip.checked = TRUE) then intAnlClip := 1 else intAnlClip := 0;

  dbase.anlAbs := intAnlAbs;
  dbase.anlClip := intAnlClip;

  if (timeChanged = TRUE) then
  begin
     dbase.clkHour := cbClkHour.ItemIndex;
     dbase.clkMinute := cbClkMinute.ItemIndex;
     dbase.clkSecond := cbClkSecond.ItemIndex;
     dbase.clkYear := cbClkYear.ItemIndex;
     dbase.clkMonth := (cbClkMonth.ItemIndex)+1;
     dbase.clkDay := (cbClkDay.ItemIndex)+1;
  end;
  dbase.time_format := CBTimeFormat.ItemIndex;
  dbase.date_format := CBDateFormat.ItemIndex;

  if (CkBQafEnable.checked = TRUE) then intQafEnable := 1 else intQafEnable := 0;

  dbase.qafEnable := intQafEnable;
  dbase.qafDay := (cbQafDay.ItemIndex)+1;
  dbase.qafMonth := (cbQafMonth.ItemIndex)+1;
  dbase.qafYear := cbQafYear.ItemIndex;

  dbase.brightness := cbBrightness.ItemIndex;
  dbase.secondary_units := CBSecondaryUnits.ItemIndex;
  dbase.tertiary_units := CBTertiaryUnits.ItemIndex;
  dbase.conversion_factor := my_strtoint(EdtConversionFactor.Text);
  dbase.show_lboz := CBShowLbOz.ItemIndex;

  dbase.setp_opt_jog_on := my_strtoint(EdtSetpJogOn.Text);
  dbase.setp_opt_jog_off := my_strtoint(EdtSetpJogOff.Text);
  dbase.setp_opt_jogs_in_set := my_strtoint(EdtSetpOptJogSet.Text);
  dbase.setp_opt_max_jog_sets := my_strtoint(EdtSetpOptMaxJogSets.Text);
  dbase.setp_opt_feeder_type := CBSetpOptFeederType.ItemIndex;
  dbase.setp_opt_delay_check := my_strtoint(EdtSetpOptDelayCheck.Text);

  if (CkBSenseLine.checked = TRUE) then intSenseLine := 1 else intSenseLine := 0;
  dbase.senseLine := intSenseLine;

  update_status();
end;

procedure TFrmMain.setp_to_dialog(setp: integer);
var
  temp: string;
begin
  CBxSetpType.itemindex := dbase.setp_data[setp].setp_type;
  CBxSetpSrc.itemindex := dbase.setp_data[setp].setp_src;
  CBxSetpLogic.itemindex := dbase.setp_data[setp].setp_logic;
  CBxSetpLock.itemindex := dbase.setp_data[setp].setp_lock;
  CBxSetpAlarm.itemindex := dbase.setp_data[setp].setp_alarm;
  CBSetpTiming.itemindex := dbase.setp_data[setp].setp_timing;
  CBSetpReset.itemindex := dbase.setp_data[setp].setp_reset;

  EdtInflight.Text := fmt_int(dbase.setp_data[setp].setp_inflight, dbase.dp_pos, datViewer.DecimalPointChar);
  EdtHysteresis.Text := fmt_int(dbase.setp_data[setp].setp_hysteresis, dbase.dp_pos, datViewer.DecimalPointChar);
  EdtTarget.Text := fmt_int(dbase.setp_data[setp].setp_target, dbase.dp_pos, datViewer.DecimalPointChar);

  temp := CbxUnits.Items.Strings[dbase.units];
  lblInflightUnits.caption := CbxUnits.Items.Strings[dbase.units];
  lblHysteresisUnits.caption := lblInflightUnits.caption;
  lblTargetUnits.caption := lblInflightUnits.caption;

  setp_changed := true;

end;

procedure TFrmMain.dialog_to_setp(setp: integer);
begin
  dbase.setp_data[setp].setp_type   := CBxSetpType.itemindex;

  dbase.setp_data[setp].setp_src    := CBxSetpSrc.itemindex;
  dbase.setp_data[setp].setp_logic  := CBxSetpLogic.itemindex;
  dbase.setp_data[setp].setp_lock   := CBxSetpLock.itemindex;
  dbase.setp_data[setp].setp_alarm  := CBxSetpAlarm.itemindex;
  dbase.setp_data[setp].setp_timing := CBSetpTiming.itemindex;
  dbase.setp_data[setp].setp_reset  := CBSetpReset.itemindex; 

  dbase.setp_data[setp].setp_inflight   := my_strtoint(EdtInflight.text);
  dbase.setp_data[setp].setp_hysteresis := my_strtoint(EdtHysteresis.text);
  dbase.setp_data[setp].setp_target     := my_strtoint(EdtTarget.text);
end;

procedure TFrmMain.FixGraph;
var
  x1, x2 : double;
  num : integer;
  i : integer;
begin
  if Chart.SeriesList.Series[5].Count <= 2 then exit;

  // count same xvalue
  x2 := Chart.SeriesList.Series[5].XValue[chart.SeriesList.Series[5].Count-1];

  num := 0;
  x1 := chart.SeriesList.Series[5].XValue[chart.SeriesList.Series[5].Count-2];
  while (x1 = x2) do begin
    num := num + 1;
    if (chart.SeriesList.Series[5].Count <= (num+1)) then exit;
    x1 := chart.SeriesList.Series[5].XValue[chart.SeriesList.Series[5].Count-num-2];
  end;

  for i := 1 to num do begin
    chart.SeriesList.Series[5].XValue[
      chart.SeriesList.Series[5].Count-i-1] := (i*(x1-x2)/(num+1)) + x2;
  end;
end;

procedure TFrmMain.LoggingCalculateNextSampleTime(CurrentTime : TDateTime);
var TimeIncrement : TDateTime;
begin
  if (FLoggingMode = lmMSVPoll) then
  begin
    // Convert milliseconds to seconds to fractions of a day (TDateTime: 1.0 = 1 day)
    TimeIncrement := FLoggingRate / 1000.0 / SecsPerDay;
    FLoggingNextSampleTime := CurrentTime + TimeIncrement;
  end;
end;

procedure TFrmMain.ProcessMsg(s: string);

procedure process_logging(msg : String);
var
  parse_ok : Boolean;
  val : Integer;
  annun : Integer;
  addr : Integer;
  tmp : Integer;
  cof12io : Integer;
  i : Integer;
  t : Double;
  SampleTime : TDateTime;

begin
  if (FLoggingMode <> lmOff) then
  begin
    Parser5100.ParseStr(msg, False, False);

    parse_ok := Parser5100.GetIntParam(0, val, tmp, 999999, -999999) and
                Parser5100.GetIntParam(1, addr, tmp, 32, 0) and
                Parser5100.GetIntParam(2, annun, tmp, 999, 0);
    if (parse_ok and FSupportsCof12) then
    begin
      parse_ok := Parser5100.GetIntParam(3, cof12io, tmp, 999, 0);
    end;

    if (parse_ok) then
    begin
      SampleTime := Now;

      t := (SampleTime - FLoggingStartTime) * SecsPerDay;
      if (t > logOldTime) then
        FixGraph;
      logOldTime := t;

      if (FLoggingMode = lmMSVStream) or (SampleTime >= FLoggingNextSampleTime) then
      begin
        LoggingCalculateNextSampleTime(SampleTime);

        if ((t > Chart.BottomAxis.Maximum) and
            (not Chart.Zoomed) and (not logPanning)) then
        begin
          Chart.BottomAxis.Maximum := Chart.BottomAxis.Maximum + page_size;
          Chart.BottomAxis.Minimum := Chart.BottomAxis.Minimum + page_size;
        end;

        Series1.AddXY(t, (1.0 * val) / divider, '', clTeeColor);

        for i := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
        begin
          FLoggingDigitals[i].AddSeriesDataPoint(t, FSupportsCof12, annun, cof12io);
        end;
      end;
    end;
  end;
end;

var
  temps : String;

begin
  case comms_mode of
    CMidle:;
    CMlogging: process_logging(s);
    CMread: FrmTraffic.handle_msg(s, True);
    CMwrite: FrmTraffic.handle_msg(s, False);

    CMCal, CMmimic:
      begin
        Parser5100.ParseStr(s, FALSE, FALSE);
        if not waiting_for_callback then begin
          Parser5100.getStrParam(0,temps,100,12);
          if comms_mode = CMCal then begin
            LCDCal.lcd.SetSegsOnOff(temps);
            LCDCal.DrawLCD();
          end else begin
            LCDMain.lcd.SetSegsOnOff(temps);
            LCDMain.DrawLCD();
          end;
        end;
      end;
  end;
  endWaiting();
  comms_timeout := CommsTimeout;

  statusbar.panels[1].text := s;
  AddStr(s);
  if assigned(callback) then callback(s);
end;

procedure handle_dummy(s: string);
begin
   FrmMain.waiting_for_callback := FALSE;
end;

procedure TFrmMain.SendStr(s_to_send: string; useStxEtx: boolean);
var s: String;
    framed_msg : String;
begin
  if (FIOInterface.Connected) and (s_to_send <> '') then
  begin
    last_cmd := s_to_send;
    statusbar.panels[0].text := s_to_send;
    s := '>>>' + s_to_send;
    if (useStxEtx) then
    begin
      framed_msg := STX + s_to_send + ETX;
      FIOInterface.WriteString(framed_msg);
      CommsLoggingLogComms('', False, framed_msg);
    end
    else
    begin
      framed_msg := s_to_send;
      if (framed_msg[length(framed_msg)] <> ';') then
      begin
        framed_msg := framed_msg + ';';
        s := s + ';';
      end;
      FIOInterface.WriteString(framed_msg);
      CommsLoggingLogComms('', False, framed_msg);
    end;
    Addstr(s);
  end;
end;

function TFrmMain.SendStr_callback_timeout(s_to_send: string; useStxEtx: boolean;
    reply: string;
    call_f: Tcallback;
    timeout : Integer): boolean;
begin
   result := False;
   if FIOInterface.Connected then
   begin
     callback_reply := reply;
     callback_timer := timeout;
     waiting_for_callback := true;
     callback := call_f;
     SendStr(s_to_send,useStxEtx);
     while waiting_for_callback do
       Application.HandleMessage;
     result := (callback_timer > 0);
     callback := NIL;
   end;
end;

function TFrmMain.SendStr_callback(s_to_send: string; useStxEtx: boolean; reply: string; call_f: Tcallback): boolean;
begin
  Result := Self.SendStr_callback_timeout(s_to_send, useStxEtx, reply, call_f, CommsTimeout);
end;

procedure TFrmMain.AddStr(s: string);
var i : integer;
begin
  if PgCMain.ActivePage = TSTest then begin
    if MemoRx.Lines.Count > MAXLINES then begin
      memorx.Lines.BeginUpdate;
      for i := 0 to 9 do MemoRx.lines.delete(0);
      memorx.Lines.EndUpdate;
    end;
    MemoRx.lines.Add(s);
  end;
end;

procedure TFrmMain.Open1Click(Sender: TObject);
var list: TStringList;
    load_log : Boolean;
    can_load : Boolean;
begin
  load_log := (PgCMain.ActivePage = TSLog);

  if (load_log) then
  begin
    OpenDialog.Title := 'Open Indicator Log File';
    OpenDialog.DefaultExt := 'log';
    OpenDialog.FilterIndex := 0;
    OpenDialog.Filter := 'Indicator Log (*.log)|*.log|All Files (*.*)|*.*';
  end
  else
  begin
    OpenDialog.Title := 'Open Indicator Setting File';
    OpenDialog.DefaultExt := 'ris';
    OpenDialog.FilterIndex := 0;
    OpenDialog.Filter := 'Indicator Settings (*.ris)|*.ris|All Files (*.*)|*.*';
  end;
  OpenDialog.Filename := '';

  if OpenDialog.Execute() then
  begin
    list := TStringList.Create();
    try
      list.LoadFromFile(OpenDialog.Filename);
      if (load_log) then
      begin
        // Load chart from log file
        slist_to_log(list);
        SetupChart(False);
        fit_chart();
      end
      else
      begin
        // Load settings from file
        if FIOInterface.Connected then
        begin
          inhibitMSV := True;
          try
            my_delay(CommsTimeout);
            can_load := SendStr_callback('WFP?', False, 'WFP', handle_WFP);
          finally
            inhibitMSV := False;
          end;
        end
        else
        begin
          can_load := True;
        end;

        if (can_load) then
        begin
          dbase.slist_to_dbase(list);
          SetupChart(True);
          dbase_to_dialog(False);
          setp_to_dialog(CtrlSetpoint.TabIndex);
          set_setp_enabled();
          TSCal.tabvisible := True;
          TSSettings.tabvisible := True;
          TSlog.tabvisible := True;
          dbase.serial := '';
          unit_info_saved := False;
          update_status();
        end;
      end;
    finally
      list.Free();
    end;
  end;
end;

procedure TFrmMain.Exit1Click(Sender: TObject);
begin
    Application.Terminate;
end;

procedure TFrmMain.Save1Click(Sender: TObject);
var list: TStringList;
    save_log : Boolean;
begin
  save_log := (PgCMain.ActivePage = TSLog);

  if (save_log) then
  begin
    SaveDialog.Title := 'Save Indicator Log File';
    SaveDialog.DefaultExt := 'log';
    SaveDialog.FilterIndex := 0;
    SaveDialog.Filter := 'Indicator Log (*.log)|*.log|All Files (*.*)|*.*';
  end
  else
  begin
    SaveDialog.Title := 'Save Indicator Setting File';
    SaveDialog.DefaultExt := 'ris';
    SaveDialog.FilterIndex := 0;
    SaveDialog.Filter := 'Indicator Settings (*.ris)|*.ris|All Files (*.*)|*.*';
  end;
  SaveDialog.Filename := '';

  if SaveDialog.Execute() then
  begin
    list := TStringList.Create();
    try
      if (save_log) then
      begin
        log_to_slist(list);
      end
      else
      begin
        if (dbase_changed) then dialog_to_dbase();
        if (setp_changed) then dialog_to_setp(CtrlSetpoint.TabIndex);
        dbase.dbase_to_slist(list);
      end;
      list.SaveToFile(SaveDialog.Filename);
    finally
      list.free();
    end;
  end;
end;

procedure TFrmMain.Print1Click(Sender: TObject);
var
  i: integer;
  f: textfile;
  list: Tstringlist;
  h, w: longint;
begin
   if PrintDialog.execute then begin
     Screen.Cursor := crHourGlass;
     Printer.canvas.font := MemoHeader.font;
     if PgCMain.ActivePage = TSLog then
     begin
        Printer.BeginDoc;
        try
          h := Printer.PageHeight;
          w := Printer.PageWidth;

          // And now print the chart component...
          Chart.PrintPartial(Rect(w div 20,          { <-- left margin }
                                  h div 10 ,          { <-- top margin }
                                  w - (w div 20),    { <-- right margin }
                                  h - (h div 10))); { <-- bottom margin }
          Printer.EndDoc();
        except
          on Exception do  { just in case an error happens... }
            Begin
             Printer.Abort;
             Printer.EndDoc;
             Raise;       { <-- raise up the exception !!! }
            end;
        end;
      end
     else begin
       list := Tstringlist.create;
       AssignPrn(f);
       rewrite(f);

       try
       dbase_to_plist(list);
       writeln(f);
       writeln(f);
       writeln(f);
       for i := 0 to list.Count - 1 do begin
          writeln(f,'     ',list[i]);
         end;
       finally
         list.free();
         closefile(f);
       end;
     end;
      Screen.Cursor:=crDefault;
    end;
end;

////////////////////////////////////////////////////////////////////////////////////////////////////

procedure TFrmMain.FIOInterfaceReceive( const Str : String );
var
   i: word;
   c: char;
begin
  if closing then
    exit;

  for i := 1 to Length(Str) do
  begin
    c := Str[i];

    if ((c = CR) or (c = LF) or (c = ETX)) then
    begin
      if (CompleteMsgBuffer <> '') then
      begin
        CommsLoggingLogComms('', True, CompleteMsgBuffer + c);
        ProcessMsg(CompleteMsgBuffer);
      end;
      MsgBuffer := '';
      CompleteMsgBuffer := '';
    end
    else if c = STX then
    begin
      MsgBuffer := '';
      CompleteMsgBuffer := '';
    end
    else
    begin
      MsgBuffer := MsgBuffer + c;
      CompleteMsgBuffer := CompleteMsgBuffer + c;
      if length(MsgBuffer) > 100 then
      begin
        AddStr(MsgBuffer);
        MsgBuffer := '';
      end;
    end; // case ch
  end; // for all chars
end;

// Set all comms variables to some kind of sane state
procedure TFrmMain.InitialiseCommsVariables();
begin
  MsgBuffer := '';
  CompleteMsgBuffer := '';
  waiting_for_callback := False;
  callback_timer := 0;
  comms_timeout := CommsTimeout;
  inhibitMSV := False;
  callback := handle_dummy;
  query_type := 100; // 1000/100 = 100ms for FPL
end;

procedure TFrmMain.SetAllLCDSegs(on : Boolean);
var i : Integer;
    s : String;
    ch : Char;
begin
  if (on) then
    ch := 'F'
  else
    ch := '0';
  s := '';
  for i := 0 to (lcdMain.lcd.NumSegments div 4) - 1 do
  begin
    s := s + ch;
  end;

  LCDMain.lcd.SetSegsOnOff(s);
end;

procedure TFrmMain.EnableWhenConnected( Connected : Boolean );
begin
  if (Connected) then
  begin
    // We need a 1 second delay here because for some reason
    // the WE2111 doesn't start answering commands immediately
    // after accepting a connnection. See http://bugs.rinstrumau.local/show_bug.cgi?id=83
    my_delay(100);
  end;

  TSTest.TabVisible := Connected;
  TSCal.TabVisible := False;
  TSSettings.TabVisible := False;
  ReadSettings1.Enabled := Connected;
  ToolButton6.Enabled := ReadSettings1.Enabled;
  WriteSettings1.Enabled := Connected;
  ToolButton7.Enabled := WriteSettings1.Enabled;

  if (Connected) then
  begin
    ToolButton4.Caption := '&Disconnect';
    ToolButton4.Hint := 'Disconnect from instrument';
    if (PgCMain.ActivePage = TSDisplay) then
      comms_mode := CMMimic;
    activate_unit();
    if(MyPollStatusThread = nil) or (MyPollStatusThreadActive = false) then
      MyPollStatusThread := TPollStatusThread.Create(False);
      MyPollStatusThreadActive := true;
  end
  else
  begin
    ToolButton4.Caption := '&Connect';
    ToolButton4.Hint := 'Connect to instrument';

    // Prevent timeout uprm clearing display, and set all segments on (like initial state)
    comms_timeout := 0;
    comms_mode := CMidle;
    SetAllLCDSegs(True);
    dbase.serial := '';
    update_status();
  end;
  Connect2.caption := ToolButton4.Caption;

  if (not Connected) then
    FLoggingMode := lmOff;
  LoggingButtonsEnable();
end;

procedure TFrmMain.FIOInterfaceConnect( Sender: TObject );
begin
  CommsLoggingLogMessage('TFrmMain.FIOInterfaceConnect: Connected to indicator');
  EnableWhenConnected(True);
end;


procedure TFrmMain.FIOInterfaceDisconnect( Sender: TObject );
begin
  CommsLoggingLogMessage('TFrmMain.FIOInterfaceDisconnect: Disconnected from indicator');
  EnableWhenConnected(False);
end;

procedure TFrmMain.ConnectDisconnect;
var
  NewIOIface : TIOIface;
begin
  CommsTimeout := datViewer.Timeout;
  if (FIOInterface.Connected) then
  begin
    FIOInterface.Disconnect();
    update_status();
  end
  else
  begin
    NewIOIface := CreateConfigureIOInterface(datViewer, cur_unit);
    CommsTimeout := datViewer.Timeout;
    if Assigned(NewIOIface) then
    begin
      FIOInterface.Free();
      FIOInterface := NewIOIface;
      FIOInterface.OnReceive := FIOInterfaceReceive;
      FIOInterface.OnConnect := FIOInterfaceConnect;
      FIOInterface.OnDisconnect := FIOInterfaceDisconnect;

      InitialiseCommsVariables();
      FIOInterface.Connect();
      update_status();
    end;
  end;
end;

procedure TFrmMain.Connect2Click(Sender: TObject);
begin
  ConnectDisconnect();
end;

procedure TFrmMain.EdtSendStrKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = CR then
  begin
    SendStr(EdtSendstr.text,cbStxEtx.checked);
    ActiveControl := BtnSend;
    ActiveControl := EdtSendStr;
  end;
end;

procedure TFrmMain.BtnClearClick(Sender: TObject);
begin
  MemoRx.Lines.Clear();
  ActiveControl := EdtSendStr;
end;

procedure TFrmMain.CbStxEtxClick(Sender: TObject);
begin
  ActiveControl := EdtSendStr;
end;

procedure TFrmMain.BtnSendClick(Sender: TObject);
begin
  SendStr(EdtSendstr.text,cbStxEtx.checked);
  ActiveControl := EdtSendStr;
end;

procedure TFrmMain.Timer1Timer(Sender: TObject);
begin
  // decrement the ms counter used in my_delay()
  if delay_timer > 0 then
    dec(delay_timer);

// allows the display to be updated (all segs on) after comms is disconnected
  inc(sec_timer);
// sec_timer reset every 1000/100 = 100ms
  if sec_timer >= (1000 / timer1.Interval) then
    sec_timer := 0;

  if (comms_timeout > 0) then
  begin
    dec(comms_timeout);
    if (comms_timeout = 0) then
    begin
      SetAllLCDSegs(False);
      lcdMain.DrawLCD;
    end;
  end;

  if (FIOInterface.Connected) then
  begin
    if (not waiting_for_callback) then
    begin
      case comms_mode of
        CMidle:;
        CMtest:;
        CMread:;
        Cmwrite:;
        CMlogging:; // now handled in a separate thread
        CMCal, CmMimic:; // now handled in a separate thread
      end;
    end;

    if callback_timer > 0 then
    begin
      dec(callback_timer);
      if (callback_timer = 0) and waiting_for_callback then
      begin
        waiting_for_callback := False;
        ShowMessage('Instrument Not Responding');
        CommsLoggingLogMessage('TFrmMain.Timer1Timer: Instrument Not Responding');
      end;
    end;
  end;

lcdMain.btns.MonitorTimeout(LongPressMs);
if sec_timer = 0 then
  lcdMain.DrawLCD;
end;

procedure TFRMMain.MimicClick(Sender: TObject; btnIndex : integer; msDown : integer);
var
  s : string;
begin
  if FIOInterface.Connected then
  begin
    s := '';
    btnIndex := btnIndex + 1;
    if msDown >= LongPressMs then
    begin
      s := Format('FPL%d,1', [btnIndex]);
    end
    else
    begin
      s := Format('FPL%d', [btnIndex]);
    end;
    if s <> '' then
    begin
      SendStr(s, False);
    end;
  end
  else
  begin
    MessageDlg('Instrument must be connected', mtInformation, [mbOK], 0);
  end;
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var i : integer;
    bg_img_filename : String;
    LogDigitalSeries: Array[0..NUM_DIGITAL_LOG_SERIES - 1] of TLineSeries;
begin
   Caption := Application.Title;

   FIOInterface := TIOIfaceNull.Create( nil );
   FIOInterface.OnReceive := FIOInterfaceReceive;

   closing := false;

   bg_img_filename := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName)) + datViewer.BackgroundImageFilename;

   lcdMain := TKenMimicDisp.Create(self);
   lcdMain.Parent := TSDisplay;
   lcdMain.Align := alClient;
   lcdMain.Enabled := True;
   lcdMain.Visible := True;
   lcdMain.lcd.onColor := clYellowGreen;
   lcdMain.LCDTop := 0;
   lcdMain.LCDLeft := 0;
   lcdMain.LCDWidth := 1000;
   lcdMain.LCDHeight := 1000;
   lcdMain.backgroundFilename := bg_img_filename;
   lcdMain.lcdFilename := ChangeFileExt(Application.ExeName, 'lcd.KB2');
   lcdMain.keyFilename := ChangeFileExt(Application.ExeName, 'key.KB2');
   lcdMain.btns.OnMouseClick := MimicClick;

   lcdCal := TKenMimicDisp.Create(self);
   lcdCal.Parent := pnlDispCal;
   lcdCal.Align := alClient;
   lcdCal.Enabled := True;
   lcdCal.Visible := True;
   lcdCal.lcd.onColor := clYellowGreen;
   lcdCal.LCDTop := 0;
   lcdCal.LCDLeft := 0;
   lcdCal.LCDWidth := 1000;
   lcdCal.LCDHeight := 1000;
   lcdCal.backgroundFilename := bg_img_filename;
   lcdCal.lcdFilename := ChangeFileExt(Application.ExeName, 'lcd.KB2');

   Application.HelpFile := ChangeFileExt(application.exename, '.chm');

   InitialiseCommsVariables();

   comms_mode := CMidle;
   Parser5100 := TcommsObj.create();
   dbase := Tdata5100.create();
   dbase_backup := Tdata5100.create();
   dbase_changed := False;
   setp_changed := false;
   PgCMain.ActivePage := TSDisplay;
   PgCSettings.ActivePage := TSBuild;
   LBxLCal.itemindex := 0;

   calibrating := False;
   display_units := 0;
   cur_unit := 99;

   delay_timer := 0;
   sec_timer := 0;

   unit_info_saved := True;

   // Logging/chart stuff
   FSupportsCof12 := False;
   FLoggingMode := lmOff;
   FLoggingRate := 0;

   LogDigitalSeries[0] := Series2;
   LogDigitalSeries[1] := Series3;
   LogDigitalSeries[2] := Series4;
   LogDigitalSeries[3] := Series5;
   LogDigitalSeries[4] := Series6;
   LogDigitalSeries[5] := Series7;
   LogDigitalSeries[6] := Series8;
   LogDigitalSeries[7] := Series9;
   for i := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
   begin
     FLoggingDigitals[i] := TLoggingInfo.Create(LogDigitalSeries[i], 1 + 1.5 * i);
   end;

   for i := 0 to Chart.SeriesCount - 1 do
     Chart.SeriesList.Series[i].Clear;
   divider := 1;

   logPanning := false;
   logOldTime := -1;

   CBxDP.ItemIndex := 0;
   edtCalDirectZero.Text := '0';
   edtCalDirectSpan.Text := '0';
   cbxFilter.ItemIndex := 0;
   EDtRows.Text := '0';
   EDtCols.Text := '0';

   edtAutoStartChar.Text := '';
   edtAutoEndChar1.Text := '';
   edtAutoEndChar2.Text := '';

   EnableWhenConnected(False);

   if ('.' = datViewer.DecimalPointChar) then
     mnuDPPoint.Checked := True
   else
     mnuDPComma.Checked := True;
   Self.UpdateDecimalPointCharChange();

   if (datViewer.CommsLoggingEnabled) then
   begin
     CommsLoggingInit(datViewer.CommsLoggingFile);
   end;

   BitBtnStaticIpDefaults.Caption := 'Static IP' + #13 + 'Defaults';
end;

procedure TFrmMain.PgCMainChange(Sender: TObject);
begin
  if PgCMain.ActivePage <> TSSettings then
  begin
    if dbase_changed then
      dialog_to_dbase();
      check_dbase_changed();
  end;

  if PgCMain.ActivePage = TSDisplay then
  begin
    comms_mode := CMmimic;
    activate_unit();
    if(MyPollStatusThread = nil) or (MyPollStatusThreadActive = false) then
      MyPollStatusThread := TPollStatusThread.Create(False);
      MyPollStatusThreadActive := true;
  end
  else if PgCMain.ActivePage = TSCal then
  begin
    comms_mode := CMcal;
    if (StatusBar.Panels.Items[2].Text <> '') and (not unit_info_saved) then
    begin
      if MessageDlg('Current Settings not sent to instrument.  Send now?',
                    mtConfirmation, [mbYes,mbNo],0) = mrYes then
        WriteSettings1Click(self);
    end;
    if(MyPollStatusThread = nil) or (MyPollStatusThreadActive = false) then
      MyPollStatusThread := TPollStatusThread.Create(False);
      MyPollStatusThreadActive := true;
  end
  else if PgCMain.ActivePage = TSTest then
  begin
    activecontrol := EdtSendStr;
    comms_mode := CMtest;
  end
  else if PgCMain.ActivePage = TSSettings then
  begin
    dbase_to_dialog(False);
    PgCSettings.ActivePage := TSBuild;
  end
  else if PgCMain.ActivePage = TSLog then
  begin
    SetupChart(True);
    comms_mode := CMlogging;
    activecontrol := chart;
  end
  else
  begin
    comms_mode := CMidle;
  end;
end;

procedure TFrmMain.SetupSeriesTitles;
begin
  // Show Series 1: weight
  loginfo.SetupSeries(Series1, True, 'Weight');

  // Show digital series not required because FLoggingDigitals[].SetLogType() does it
end;

procedure TFrmMain.SetupUnitForLogging();
begin
  Screen.Cursor := crHourGlass;
  if (SendStr_callback(GetSelStr(cur_unit) + 'COF12;', False, '', handle_ok_silent)) then
  begin
    FSupportsCof12 := True;
  end
  else
  begin
    FSupportsCof12 := False;
    SendStr_callback(GetSelStr(cur_unit) + 'COF11;', False, '', handle_ok);
  end;
  Screen.Cursor := crDefault;
end;

procedure TFrmMain.LoggingButtonsEnable;
begin
  BtnStart.Enabled := (FLoggingMode = lmOff) and (FIOInterface.Connected);
  BtnStop.Enabled := (FLoggingMode <> lmOff) and (FIOInterface.Connected);  
end;

procedure TFrmMain.BtnStartClick(Sender: TObject);

  procedure CheckNotifyCof;
  var i : Integer;
      s : String;
      badio : Boolean;
  begin
    if (not FSupportsCof12) then
    begin
      badio := False;
      s := 'Your indicator doesn''t support COF12, therefore the following IOs cannot be logged: ';

      for i := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
      begin
        if (FLoggingDigitals[i].GetLogType() in [ LOG_TYPE_IDX_OUTPUT5, LOG_TYPE_IDX_OUTPUT6, LOG_TYPE_IDX_OUTPUT7, LOG_TYPE_IDX_OUTPUT8 ]) then
        begin
          badio := True;
          s := s + Format('Digital %d: %s, ', [ i + 1, LogTypeNames[FLoggingDigitals[i].GetLogType()] ]);
        end;
      end;
      s := s + '. To log IOs 5 to 8 please upgrade the indicator.';
      if (badio) then
      begin
        MessageDlg(s, mtWarning, [ mbOk ], 0);
      end;
    end;
  end;

var i : integer;
begin
  if FIOInterface.Connected then
  begin
    if (FrmLogDialog.ShowModal() = mrOk) then
    begin
      for i := 0 to Chart.SeriesCount - 1 do
        Chart.SeriesList.Series[i].Clear;

      SetupChart(True);
      SetupSeriesTitles();
      SetupUnitForLogging();
      CheckNotifyCof();
      FLoggingMode := FrmLogDialog.GetLoggingMode();
      FLoggingStartTime := Now;
      logOldTime := -1;
      
      if (FLoggingMode = lmMSVStream) and (not inhibitMSV) then
        SendStr('MSV?,0;', False);
    end;
    LoggingButtonsEnable();
    Chart.SetFocus();
  end
  else
    ShowMessage('Instrument Not Connected');
end;

procedure TFrmMain.BtnStopClick(Sender: TObject);
begin
  if (FLoggingMode = lmMSVStream) then
  begin
    SendStr('STP;', False);
  end;
  FLoggingMode := lmOff;
  LoggingButtonsEnable();
  Chart.SetFocus();
end;

procedure TFrmMain.PrinterSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;

function CharToHex(c : char) : integer;
begin
  if (c <= '9') and (c >= '0') then
    CharToHex := ord(c) - ord('0')
  else if (c <= 'F') and (c >= 'A') then
    CharToHex := ord(c) + 10 - ord('A')
  else if (c <= 'f') and (c >= 'a') then
    CharToHex := ord(c) + 10 - ord('a')
  else
     ChartoHex := 0;
end;

function IsSetHex(c : char; b : integer) : boolean;
begin
  b := 1 shl b;
  IsSetHex := ((b and CharToHex(c)) > 0);
end;

procedure TFrmMain.FormResize(Sender: TObject);
var h : integer;
begin
  if width < 400 then width := 400;
  h := TSDisplay.ClientWidth * 65 div 140;
  if h > TSDisplay.ClientHeight then begin
    height := (height-TSDisplay.clientheight)+h;
    pnlDispFill.height := 0;
  end else begin
    pnlDispFill.height := TSDisplay.clientheight - h;
  end;
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
var i : Integer;
begin
  Parser5100.Destroy();
  CommsLoggingDestroy();

  for i := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
  begin
    FLoggingDigitals[i].Free();
    FLoggingDigitals[i] := nil;
  end;
end;

procedure TFrmMain.ChartAfterDraw(Sender: TObject);
begin
  OldX1 := -1; { Reset old mouse position }
  OldX2 := -1;
end;

procedure TFrmMain.ChartMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  { This procedure draws the crosshair lines }

Procedure DrawCross(AX,AY:Integer);
  begin
    With Chart,Canvas do
    begin
      Pen.Color:= ClYellow;
      Pen.Style:= psSolid;
      Pen.Mode:=pmXor;
      Pen.Width:=1;
      MoveTo(ax,ChartRect.Top-Height3D);
      LineTo(ax,ChartRect.Bottom-Height3D);
      MoveTo(ChartRect.Left+Width3D,ay);
      LineTo(ChartRect.Right+Width3D,ay);
    end;
  end;

Var tmpX,tmpY:Double;
begin
   // know when panning
   if Button = mbRight then logPanning := true;

   if (not((ssshift in shift) and (ssright in shift)))  {if not shift right click then clear left point also }
       and (OldX1<>-1) then
       begin
         DrawCross(OldX1,OldY1);  { draw old crosshair }
         OldX1:=-1;
       end;
   if (OldX2<>-1) then
      begin
        DrawCross(OldX2,OldY2);  { draw old crosshair }
        OldX2:=-1;
      end;

  { check if mouse is inside Chart rectangle }
  With Series1 do
  begin
   if ((ssshift in shift) and PtInRect( Chart.ChartRect, Point(X-Chart.Width3D,Y+Chart.Height3D))) then
    begin
      GetCursorValues(tmpX,tmpY);  { <-- get values under mouse cursor }
     { store old position }
      if (ssLeft in shift) then begin
        DrawCross(x,y);  { draw crosshair at current position }
        OldX1:=x;
        OldY1:=y;
        csrX1 := tmpX;
        csrY1 := tmpY;
        end
      else if (ssRight in shift) then begin
        DrawCross(x,y);  { draw crosshair at current position }
        OldX2:=x;
        OldY2:=y;
        csrX2 := tmpX;
        csrY2 := tmpY;
        end;
    end;

   if OldX1 <> -1 then begin
     if OldX2 <> -1 then  begin
            tmpX := csrX2 - csrX1;
            if tmpX < 0 then tmpX := -tmpX;
            tmpY := csrY2 - csrY1;
            if tmpY < 0 then tmpY := -tmpY;
            lblCsrPos.Caption := GetVertAxis.LabelValue(tmpY)+
                          ' '+ CbxUnits.Items.Strings[dbase.units] + '   over   ' +
                          GetHorizAxis.LabelValue(tmpX) + ' secs';
          end
     else begin
           lblCsrPos.Caption := GetVertAxis.LabelValue(csrY1)+
                          ' '+  CbxUnits.Items.Strings[dbase.units] +'   at   ' +
                          GetHorizAxis.LabelValue(csrX1) + ' sec';
         end;
     end
   else
       lblCsrPos.Caption := '';
  end;
end;

procedure TFrmMain.ReadSettings1Click(Sender: TObject);
var
  temp: TCommsMode;
  l1, l2: TstringList;
begin
  if FIOInterface.Connected then
  begin
    inhibitMSV := true;
    try
      my_delay(CommsTimeout);

      temp := comms_mode;
      comms_mode := CMread;
      FrmTraffic.Parser5100 := Parser5100;
      SetAllLCDSegs(False);
      LCDMain.DrawLCD();

      l1 := Tstringlist.create();
      l2 := Tstringlist.create();
      try
        with FrmTraffic do
        begin
          caption := 'Read Settings from Instrument';
          dbase.get_settings(true, l1, l2);
          add_msg_list(l1, l2);
          Animate.Active := True;
          if FrmTraffic.ShowModal() <> MrCancel  then
          begin
            dbase.slist_to_dbase(FrmTraffic.msg_data);
            dbase_backup.slist_to_dbase(FrmTraffic.msg_data);
            SetupChart(True);
            TSCal.tabvisible := True;
            TSSettings.tabvisible := true;
            unit_info_saved := true;
            display_units := dbase.units;
            update_status();
          end; // if
          Animate.Active := False;
        end; // with
        comms_mode := temp;
        dbase_to_dialog(False);
        setp_to_dialog(CtrlSetpoint.TabIndex);
        set_setp_enabled();
        CtrlSetpoint.invalidate;
        if (comms_mode = CmMimic) or (comms_mode = CmCal) then
        begin
          if (MyPollStatusThread = nil) or (MyPollStatusThreadActive = false) then
            MyPollStatusThread := TPollStatusThread.Create(False);
          MyPollStatusThreadActive := true;
        end;
      finally
        l1.free();
        l2.free();
      end
    finally
      inhibitMSV := false;
    end;
  end
  else
  begin
    ShowMessage('Instrument Not Connected');
  end;
end;

procedure TFrmMain.WriteSettings1Click(Sender: TObject);
var
  temp: TCommsMode;
  list, backup_list: TstringList;

begin
  //if (dbase_changed) then
  dialog_to_dbase();
  if (setp_changed) then dialog_to_setp(CtrlSetpoint.TabIndex);
  if  not TSCal.TabVisible then exit;

  if FIOInterface.Connected then begin
    inhibitMSV := true;
    try
      my_delay(CommsTimeout);

      temp := comms_mode;
      list := Tstringlist.create();
      backup_list := Tstringlist.create();
      try
        dbase.dbase_to_slist(list);
        dbase_backup.dbase_to_slist(backup_list);
        remove_duplicates(list,backup_list);
        if read_cal_settings(list) then begin
          if dbase.cal_change(list) then begin
            sendstr_callback('PCD?',false,'PCD',handle_Q);
            if callback_params[0] <> 0 then begin
              with FrmPasscode do begin
                Edtpasscode.text := '';
                if (showmodal() = mrCancel) or
                   not sendstr_callback(format('PCD%s',[Edtpasscode.text]),
                    false,'',handle_ok) then   exit;
              end;  // with
            end;
          end;

          comms_mode := CMwrite;
          FrmTraffic.Parser5100 := Parser5100;
          SetAllLCDSegs(False);
          LCDMain.DrawLCD();
          with FrmTraffic do begin
            add_msg_list(list,list);
            caption := 'Write Settings to Instrument';
            PBprogress.Position := 0;
            Animate.Active := True;
            if FrmTraffic.ShowModal() <> MrCancel  then begin
              dbase_backup.slist_to_dbase(list);
              Screen.Cursor := crHourGlass;
              sendstr_callback('PCD',false,'',handle_ok);
              display_units := dbase.units;
              unit_info_saved := true;
              Screen.Cursor:=crDefault;
            end;
            Animate.Active := False;
          end;
        end else begin
          Screen.Cursor := crHourGlass;
          unit_info_saved := true;
          Screen.Cursor:=crDefault;
        end;
      finally
        list.free();
        backup_list.Free();
        timeChanged := false;
      end;

      sendstr_callback('TDD1',false,'', handle_ok); // added by Ken 6.11.2001

      comms_mode := temp;
      update_status();
      if (comms_mode = CmMimic) or (comms_mode = CmCal) then
      begin
     if(MyPollStatusThread = nil) or (MyPollStatusThreadActive = false) then
      MyPollStatusThread := TPollStatusThread.Create(False);
      MyPollStatusThreadActive := true;
      end;
      
    finally
      inhibitMSV := false;
    end;
  end else begin
    ShowMessage('Instrument Not Connected');
  end;
end;

procedure TFrmMain.CtrlSetpointChange(Sender: TObject);
begin
   setp_to_dialog(CtrlSetpoint.TabIndex);
   set_setp_enabled();
end;

procedure TFrmMain.CtrlSetpointChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
   if (ActiveControl is TEdit) and (ActiveControl.parent = CtrlSetpoint) then
     EdtFS1Exit(ActiveControl);
   if (setp_changed) then dialog_to_setp(CtrlSetpoint.TabIndex);
end;

procedure TFrmMain.TSSetpointExit(Sender: TObject);
begin
  if (setp_changed) then dialog_to_setp(CtrlSetpoint.tabindex);
end;

procedure TFrmMain.PgCSettingsChange(Sender: TObject);
begin
    dialog_to_dbase();
    if  PgCSettings.ActivePage = TSSetpoint then begin
      CtrlSetpoint.tabindex := 0;
      setp_to_dialog(0);
      set_setp_enabled();
    end;
end;

procedure TFrmMain.set_setp_enabled();
begin
end;

procedure TFrmMain.CBxSetpTypeChange(Sender: TObject);
begin
  { dialog_to_setp(CtrlSetpoint.TabIndex); }
   set_setp_enabled();
   CtrlSetpoint.invalidate;
end;

procedure TFrmMain.BtnSetpClearClick(Sender: TObject);
//var
//  i: integer;
begin
  dbase.clear_setp(0,TRUE);
  setp_to_dialog(CtrlSetpoint.TabIndex);
  set_setp_enabled();
  CtrlSetpoint.invalidate;
end;

procedure TFrmMain.CtrlSetpointDrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);

var
   r1: TRect;
   index: integer;

begin
    index := TabIndex;
    with CtrlSetpoint do begin
  //    Canvas.FillRect(rect);
      r1 := rect;
      r1.Top := r1.top + 3;
      if active then begin
           r1.Top := r1.top + 2;
           r1.left := r1.left + 2;
         end;
      if dbase.setp_data[index].setp_type <> SETP_TYPE_OFF then begin
         Canvas.Font.color := clnavy;
         Canvas.Font.Style := [fsbold];
         r1.Left := r1.left + 2;
//         Canvas.Font.Size := 11;
      end else begin
         Canvas.Font.color := clblack;
         Canvas.Font.Style := [fsitalic];

    //        Canvas.Font.Size := 8;
      end;
      Canvas.TextRect(rect,r1.left,r1.top,format('%2d',[index+1]));
     end;
end;

var
  {                                   filter, fs1,    fs2,    zband,  row, col, dly, jon, adj, joff, jset, cwgt,   lcwgt,  inflight, tolerance, target, conversion factor, jog on, jog off, jogs in set, max jog sets, delay check }
  max_val: array[1..22] of integer = (60,     999999, 999999, 999999, 10,  20,  200, 200, 100, 200,  99,   999999, 999999, 999999,   999999,    999999, 999999,            60000,  60000,   20,          20,           60000);
  min_val: array[1..22] of integer = (15,     100,    100,    0,      0,   0,   0,   1,   0,   1,    1,    10,     10,     0,        0,         -99999, 1,                 100,    100,     1,           0,            0);
  dp_posn: array[1..22] of integer = (0,      0,      0,      0,      0,   0,   0,   0,   0,   0,    0,    0,      0,      0,        0,         0,      3,                 0,      0,       0,           0,            0);

function chk_num(s: string; tag: integer): boolean;
var
  tmp: integer;
begin
   tmp := my_strtoint(s);
   result := ((tmp >= min_val[tag]) and (tmp <= max_val[tag]));
end;

procedure TFrmMain.EdtFS1KeyPress(Sender: TObject; var Key: Char);
var Edit : TEdit;
begin
  case key of
    ' ','+','-','.',',':
      ;
    #13:
    begin
      if (Sender is TEdit) then
      begin
        Edit := Sender as TEdit;
        Edit.Text := fmt_num(Edit.Text, CBxDp.ItemIndex, datViewer.DecimalPointChar);
        key := #0;
      end;
    end;
  else
    if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then
      key := #0;
  end;
end;

procedure TFrmMain.EdtFS1Exit(Sender: TObject);
var Edit : TEdit;
begin
  if Sender is TEdit then
  begin
    Edit := Sender as TEdit;
    Edit.Text := fmt_num(Edit.Text, CBxDp.ItemIndex, datViewer.DecimalPointChar);
    if not chk_num(Edit.Text, Edit.Tag) then
    begin
      MessageDlg(Format('Out of Range: (%s to %s)',
                        [fmt_int(min_val[Edit.Tag], CBxDp.itemindex, datViewer.DecimalPointChar),
                         fmt_int(max_val[Edit.Tag], CBxDp.itemindex, datViewer.DecimalPointChar)]),
                 mtError, [mbOK], 0);
      SetFocus;
    end;
  end;
end;

procedure TFrmMain.EdtFilterKeyPress(Sender: TObject; var Key: Char);
{ use this for all numeric entry that is not weight related}
begin
  case key of
    ' ','+','-','.',',':
      ;
    #13:
      begin
        with sender as Tedit do
          Text := fmt_num(Text, 0, datViewer.DecimalPointChar);
        key := #0;
      end;
  else
    if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then
      key := #0;
  end;
end;

procedure TFrmMain.EdtDelayExit(Sender: TObject);
var Edit : TEdit;
begin
  if Sender is TEdit then
  begin
    Edit := Sender as TEdit;
    Edit.Text := fmt_num(Edit.Text, 1, datViewer.DecimalPointChar);
    if not chk_num(Edit.Text, Edit.Tag) then
    begin
      MessageDlg(Format('Out of Range: (%s to %s)',
                        [fmt_int(min_val[tag], 1, datViewer.DecimalPointChar),
                         fmt_int(max_val[tag], 1, datViewer.DecimalPointChar)]),
                 mtError, [mbOK], 0);
      SetFocus;
    end;
  end;
end;

procedure TFrmMain.EdtDelayKeyPress(Sender: TObject; var Key: Char);
begin
    case key of
      ' ','+','-','.',',':;
      #13: begin
               with sender as Tedit do
                  Text := fmt_num(Text, 1, datViewer.DecimalPointChar);
               key := #0;
             end
      else
        if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then key := #0;
     end;
end;

procedure TFrmMain.BtnClearAllClick(Sender: TObject);
begin
  dbase.clear_setp(1,TRUE);
  setp_to_dialog(CtrlSetpoint.TabIndex);
  set_setp_enabled();
  CtrlSetpoint.invalidate;
end;


procedure TFrmMain.ChartZoom(Sender: TObject);
begin
  SetupChart(False);
  Chart.Invalidate;
end;

procedure TFrmMain.ChartUndoZoom(Sender: TObject);
begin
  logPanning := False;
  SetupChart(False);
  Chart.Invalidate;
end;


procedure TFrmMain.ShowCalibrationError(err : Integer);
var s : String;
    msg : String;
begin
  case err of
    101: s := 'Zero Too High (> 3 mV/V) Or Too Low (< -3 mV/V)';
    104: s := 'Span Too High (> 3.2 mV/V) Or Too Low (< -3.2 mV/V)';
    106: s := 'Internal Error';
    // These don't exist any more:
    // 102: s := 'Zero Too Low';
    // 103: s := 'Span Too Low';
    // 105: s := 'Invalid Zero Cal';
  else
    s := 'Unknown Error';
  end;
  msg := Format('Calibration Error: %d: %s', [err, s]);
  MessageDlg(msg, mtError, [mbOk], 0);
end;

procedure TFrmMain.PromptSaveCalibration;
begin
  if (MessageDlg('Save calibration in indicator? If you select ''No'' here, ''Write Settings'' can be used later to save the calibration.',
                 mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
  begin
    if (not SendStr_callback('TDD1;', False, '', handle_OK)) then
      raise Exception.Create('Save settings to indicator failed');
    unit_info_saved := False;
  end;
end;

procedure TFrmMain.SetupForCalibration;
begin
  Screen.Cursor := crHourGlass;
  lock_page();
  calibrating := True;
  my_delay(CommsTimeout);
  LCDCal.lcd.SetSegsOnOff('22002200220022002200220000000000');
  LCDCal.DrawLCD();
end;

procedure TFrmMain.TeardownAfterCalibration;
begin
  calibrating := False;
  unlock_page();
  Screen.Cursor := crDefault;
  update_status();
end;

procedure TFrmMain.WaitForCalibrationComplete(const cmd: String);
var
  waiting: Integer;
  cal_result : Integer;
begin
  waiting := 5;
  while (waiting > 0) do
  begin
    my_delay(5);
    if SendStr_callback(cmd + '?', False, cmd, handle_cal_reply) then
    begin
      cal_result := callback_params[1];
      if (cal_result = 1) then
        waiting := 5;
      if (cal_result = 0) then
        dec(waiting);
      if (cal_result > 100) then
      begin
        ShowCalibrationError(cal_result);
        waiting := 0;
      end;
    end
    else
      waiting := 0;
  end;
end;

procedure TFrmMain.BtnZeroClick(Sender: TObject);
begin
  SetupForCalibration();
  try
    if (not FIOInterface.Connected) then
      raise Exception.Create('No instrument connected');

    // Regular zero calibration
    if (not SendStr_callback('LDN;', False, '', handle_ok)) then
      raise Exception.Create('Initiating zero calibration failed');
    WaitForCalibrationComplete('LDN');
    PromptSaveCalibration();
  finally
    TeardownAfterCalibration();
  end;
  ReadSettings1Click(self);
end;

procedure TFrmMain.BtnSpanClick(Sender: TObject);
var
  cmd: String;
begin
  SetupForCalibration();
  try
    if (not FIOInterface.Connected) then
      raise Exception.Create('No instrument connected');

    // Regular span calibration
    cmd := Format('CWT%d', [my_strtoint(EdtCalWeight.text)]);
    if (not SendStr_callback(cmd, False, '', handle_ok)) then
      raise Exception.Create('Setting calibration weight failed');
    if (not SendStr_callback('LWN;', False, '', handle_ok)) then
      raise Exception.Create('Initiating span calibration failed');
    WaitForCalibrationComplete('LWN');
    PromptSaveCalibration();
  finally
    TeardownAfterCalibration();
  end;
  ReadSettings1Click(self);
end;

procedure TFrmMain.BtnLClearClick(Sender: TObject);
begin
  SetupForCalibration();
  try
    if (not FIOInterface.Connected) then
      raise Exception.Create('No instrument connected');
    if (LBxLCal.ItemIndex = -1) then
      raise Exception.Create('No linearisation point selected');

    if (not SendStr_callback(Format('LIC%d;', [LBxLCal.itemindex+1]), False, '', handle_ok)) then
      raise Exception.Create('Clearing linearisation point failed');
    if (not SendStr_callback(Format('LIC?%d;', [LbxLCal.itemindex+1]), False,
                             Format('LIC%d,', [LbxLCal.itemindex+1]), handle_LICQ)) then
      raise Exception.Create('Reading back linearisation point failed');
    PromptSaveCalibration();
  finally
    TeardownAfterCalibration();
  end;
end;

procedure TFrmMain.BtnLSetClick(Sender: TObject);
begin
  SetupForCalibration();
  try
    if (not FIOInterface.Connected) then
      raise Exception.Create('No instrument connected');
    if (LBxLCal.ItemIndex = -1) then
      raise Exception.Create('No linearisation point selected');

    if (not SendStr_callback_timeout(Format('LIC%d,%d', [LBxLCal.itemindex+1,
                                     my_strtoint(EdtLCalWeight.text)]), False, '', handle_ok, CommsTimeout * 10)) then
      raise Exception.Create('Setting linearisation point failed');
    if (not SendStr_callback(Format('LIC?%d', [LbxLCal.itemindex+1]), False,
                             Format('LIC%d,', [LbxLCal.itemindex+1]), handle_LICQ)) then
      raise Exception.Create('Reading back linearisation point failed');
    PromptSaveCalibration();
  finally
    TeardownAfterCalibration();
  end;
end;

procedure TFrmMain.EdtLCalWeightExit(Sender: TObject);
begin
  BtnLSet.Enabled := EdtLCalWeight.Text <> '';
end;

procedure TFrmMain.EdtLCalWeightKeyPress(Sender: TObject; var Key: Char);
var Edit : TEdit;
begin
  if Sender is TEdit then
  begin
    case key of
      ' ','+','-','.',',':
        ;
      #13:
      begin
        Edit := Sender as TEdit;
        Edit.Text := fmt_num(Edit.Text, CBxDp.ItemIndex, datViewer.DecimalPointChar);
        key := #0;
      end
      else
        if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then
          key := #0;
    end;
  end;
  BtnLSet.Enabled := EdtLCalWeight.Text <> '';
end;

procedure TFrmMain.UpdateLinearisationListBox(units : Integer);
var i : Integer;
    units_str : String;
    corr_weight : Integer;
begin
  units_str := CbxUnits.Items[units];
  for i := 0 to NUM_LIN_PTS - 1 do
  begin
    if dbase.lin_pc[i] = 0 then
      LBxLCal.Items[i] := Format('%d:', [i+1])
    else
    begin
      corr_weight := Round(dbase.lin_cor[i] * 10 / 16);
      LBxLCal.Items[i] := Format('%d: %4d%%   %s %s',
                                 [i + 1, dbase.lin_pc[i],
                                  fmt_int(corr_weight, dbase.dp_pos + 1, datViewer.DecimalPointChar), units_str]);
    end;
  end;
end;

procedure TFrmMain.CBxUnitsChange(Sender: TObject);
var
  pos: integer;
  s: string;
begin
  pos := CbxUnits.ItemIndex;
  if pos <> -1 then
  begin
    s := CbxUnits.Items.Strings[pos];
    lblCalWeightUnits.Caption := s;
    lblLCalWeightUnits.Caption := s;
    lblFS1Units.Caption := s;
    lblFS2Units.Caption := s;
    lblZbandUnits.Caption := s;
    lblAddTareUnits.Caption := s;
    UpdateLinearisationListBox(pos);
  end;
end;

procedure TFrmMain.About1Click(Sender: TObject);
begin
  FrmAbout.showmodal();
end;

procedure TFrmMain.MemoHeaderChange(Sender: TObject);
begin
  while memoheader.lines.Count > NUM_HEADER_LINES do begin
    memoheader.lines.Delete(memoheader.lines.count -1);
    ShowMessage('Maximum size = 6 lines x 30 characters');
  end;
end;

procedure TFrmMain.UpdateDialogDecimalPoints;
begin
  Self.dbase_to_dialog(True);
  Self.setp_to_dialog(CtrlSetpoint.TabIndex);
end;

procedure TFrmMain.CBxDPChange(Sender: TObject);
begin
  dbase.dp_pos := CBxDP.ItemIndex;
  dbase_changed := True;
  UpdateDialogDecimalPoints();
end;

procedure TFrmMain.log_to_slist(list: TStringList);
var
  s : String;
  i : Integer;
  j : Integer;
  tit : String;
begin
  if (Chart.Title.Text.Count > 0) then
    tit := Chart.Title.Text[0]
  else
    tit := '';
  list.Add(Format('%s', [tit]));

  s := '';
  for i := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
  begin
    s := s + Format('%d,', [FLoggingDigitals[i].GetLogType()]);
  end;
  list.Add(s);

  for i := 0 to Series1.XValues.Count - 1 do
  begin
    s := Format('%f,%f', [Series1.XValues[i],
                          Series1.YValues[i]]);

    for j := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
    begin
      if (FLoggingDigitals[j].GetLogType() <> LOG_TYPE_IDX_NONE) then
      begin
        if (FLoggingDigitals[j].GetSeriesYDigitalValue(i)) then
          s := s + ',1'
        else
          s := s + ',0';
      end
      else
        s := s + ',';
    end;
    list.Add(s);
  end;
end;

procedure TFrmMain.slist_to_log(const list: TStringList);
var
  Parser: Tcommsobj;
  s: String;
  i : Integer;
  j : Integer;
  dp: Integer;
  x: Double;
  logtype : Integer;
  logvalue : Integer;
begin
  Chart.Title.Text.Clear();
  for i := 0 to Chart.SeriesCount - 1 do
    Chart.SeriesList.Series[i].Clear();

  Parser := Tcommsobj.Create();
  try
    Chart.Title.Text.Add(list[0]);
    Parser.ParseStr(list[1], False, False);

    for j := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
    begin
      Parser.getIntParam(j, logtype, dp, NUM_LOG_TYPE_IDX - 1, 0);
      FLoggingDigitals[j].SetLogType(logtype);
    end;

    SetupSeriesTitles();

    for i := 2 to list.Count - 1 do
    begin
      Parser.ParseStr(list[i], False, False);
      if (Parser.getStrParam(0, s, 100, 0)) then
      begin
        x := str_to_double(s);
        if (Parser.getStrParam(1, s, 100, 0)) then
        begin
          Series1.AddXY(x, str_to_double(s), '', clTeeColor);
        end;

        for j := 0 to NUM_DIGITAL_LOG_SERIES - 1 do
        begin
          if (Parser.getIntParam(2 + j, logvalue, dp, 1, 0)) then
            FLoggingDigitals[j].AddSeriesDataPoint(x, (logvalue <> 0));
        end;
      end;
    end;
  finally
    Parser.Free();
  end;
end;

procedure TFrmMain.my_delay(cnt: integer);
begin
  delay_timer := cnt;
  while delay_timer > 0 do
    Application.HandleMessage;
end;

procedure TFrmMain.lock_page;
begin
   PgCMain.enabled := false;
   toolbar.enabled := false;
   file1.enabled := false;
   in1.enabled:= false;

   help1.enabled := false;

end;

procedure TFrmMain.unlock_page;
begin
   PgCMain.enabled := true;
   toolbar.enabled := true;
   file1.enabled := true;
   in1.enabled:= true;

   help1.enabled := true;
end;

procedure TFrmMain.ChartSetupClick(Sender: TObject);
begin
  FrmChartSetup.dp := CBxDp.itemindex;
  FrmChartSetup.EdtTstart.text := format('%f',[chart.bottomaxis.minimum]);
  FrmChartSetup.EdtTend.text := format('%f',[chart.bottomaxis.maximum]);
  FrmChartSetup.EdtMaxWgt.text := format('%f',[chart.leftaxis.maximum]);
  FrmChartSetup.EdtMinWgt.text := format('%f',[chart.leftaxis.minimum]);
  FrmChartSetup.lblMinUnits.caption := CbxUnits.Items.Strings[dbase.units];
  FrmChartSetup.lblMaxUnits.caption := CbxUnits.Items.Strings[dbase.units];

  FrmChartSetup.EdtComment.Text := Chart.Title.Text[0];
  if (FrmChartSetup.ShowModal() = mrOk) then
  begin
    Chart.Title.Text.Clear();
    Chart.Title.Text.Add(FrmChartSetup.EdtComment.Text);

    if chart.BottomAxis.Maximum <= str_to_double(FrmChartSetup.EdtTstart.Text) then
    begin
      chart.bottomaxis.maximum := str_to_double(FrmChartSetup.EdtTend.Text);
      chart.bottomaxis.minimum := str_to_double(FrmChartSetup.EdtTstart.Text);
    end
    else
    begin
      chart.bottomaxis.minimum := str_to_double(FrmChartSetup.EdtTstart.Text);
      chart.bottomaxis.maximum := str_to_double(FrmChartSetup.EdtTend.Text);
    end;
    if chart.LeftAxis.Maximum <= str_to_double(FrmChartSetup.EdtMinWgt.Text) then
    begin
      chart.leftaxis.maximum := str_to_double(FrmChartSetup.EdtMaxWgt.Text);
      chart.leftaxis.minimum := str_to_double(FrmChartSetup.EdtMinWgt.Text);
    end
    else
    begin
      chart.leftaxis.minimum := str_to_double(FrmChartSetup.EdtMinWgt.Text);
      chart.leftaxis.maximum := str_to_double(FrmChartSetup.EdtMaxWgt.Text);
    end;
  end;
end;

function TFrmMain.read_cal_settings(list: Tstringlist): boolean;
var
  temp: TCommsMode;
  l1,l2: Tstringlist;
begin
 result := false;
 if FIOInterface.Connected and (list.count > 0)then begin
  temp := comms_mode;
  comms_mode := CMread;
  FrmTraffic.Parser5100 := Parser5100;
  SetAllLCDSegs(False);
  LCDMain.DrawLCD();
  l1 := Tstringlist.create();
  l2 := Tstringlist.create();
  try
   with FrmTraffic do begin
    caption := 'Read Build Settings from Instrument';
    dbase.get_settings(false,l1,l2);
    add_msg_list(l1,l2);
    Animate.Active := True;
    if FrmTraffic.ShowModal() <> MrCancel  then begin
      remove_duplicates(list,msg_data);     {don't send cal setting information if unchanged }
      result := (list.count > 0);
     end;
    Animate.Active := False;
   end;
   comms_mode := temp;
   if (comms_mode = CmMimic) or (comms_mode = CmCal) then
   begin
    if(MyPollStatusThread = nil) or (MyPollStatusThreadActive = false) then
      MyPollStatusThread := TPollStatusThread.Create(False);
      MyPollStatusThreadActive := true;
   end;
  finally
     l1.free();
     l2.free();
  end;
 end;
end;

procedure TFrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   Xinc, Yinc: double;
begin
  if PgCMain.ActivePage = TSLog then begin
  with chart do
   try
    Xinc := (bottomaxis.maximum - bottomaxis.minimum)/10;
    Yinc := (leftaxis.maximum - leftaxis.minimum)/10;
    case key of
      VK_UP:  if ssshift in shift then
                 LeftAxis.Scroll(Yinc*10,false)
              else
                 LeftAxis.Scroll(Yinc,false);
      VK_DOWN: if ssshift in shift then
                 LeftAxis.Scroll(-Yinc*10,false)
               else
                 LeftAxis.Scroll(-Yinc,false);

      VK_LEFT: if ssshift in shift then
                   bottomaxis.scroll(-Xinc*10,false)
               else
                   bottomaxis.scroll(-Xinc,false);

      VK_RIGHT: if ssshift in shift then
                   bottomaxis.scroll(Xinc*10,false)
                else
                   bottomaxis.scroll(Xinc,false);

      VK_NEXT:  chart.zoompercent(50);
      VK_PRIOR:  chart.zoompercent(125);
      VK_HOME:  fit_chart();
     end;
     setfocus();
    except
       on E: Exception do MessageDlg(E.Message, mtError,[mbOk],E.helpcontext);
    end;

  end;
end;

procedure TFrmMain.update_status;
var str : String;
begin
  if (FIOInterface.Connected) then
    str := Format('Port: %s', [FIOInterface.GetDisplayablePort()])
  else
    str := '';

  if (dbase.serial <> '') then
  begin
    str := Format('Unit %d, SN: %s, Version %s, ID: %s, ', [dbase.netAddress, dbase.serial, dbase.version, dbase.id]) + str;
  end;
  statusbar.Panels[2].Text := str;
  statusbar.Invalidate();
end;

procedure TFrmMain.version_check(const indicator_version : String);
var viewer_vers_major : String;
    viewer_vers_minor : String;
    viewer_vers_release : String;
    ind_vers_major : String;
    ind_vers_minor : String;
    ind_vers_release : String;
    dotpos : Integer;
    temp_ind_version : String;
    vers_msg : String;
begin
  Self.GetViewerVersionTriplet(viewer_vers_major, viewer_vers_minor, viewer_vers_release);
  temp_ind_version := indicator_version;
  dotpos := Pos('.', temp_ind_version);
  if (dotpos <> 0) then
  begin
    ind_vers_major := Copy(temp_ind_version, 1, dotpos - 1);
    Delete(temp_ind_version, 1, dotpos);

    dotpos := Pos('.', temp_ind_version);
    if (dotpos <> 0) then
    begin
      ind_vers_minor := Copy(temp_ind_version, 1, dotpos - 1);
      Delete(temp_ind_version, 1, dotpos);

      ind_vers_release := temp_ind_version;

      if (viewer_vers_major <> ind_vers_major) or
         (viewer_vers_minor <> ind_vers_minor) then
       begin
         vers_msg := Format('It is recommended that the viewer version (%s.%s.x) and indicator version (%s.%s.x) match.',
                            [viewer_vers_major, viewer_vers_minor, ind_vers_major, ind_vers_minor]);
         MessageDlg(vers_msg, mtWarning, [ mbOk ], 0);
       end;
    end;
  end;
end;

procedure TFrmMain.activate_unit();
begin
  Screen.Cursor := crHourGlass;
  SendStr('S98;STP;', False);
  sendstr_callback(GetSelStr(cur_unit) + 'IDN?;', False, 'IDN', handle_IDN);
  Self.update_status();
  if sendstr_callback(GetSelStr(cur_unit) + 'ENU?;', False, 'ENU', handle_Q) then
    display_units := callback_params[0];
  Screen.Cursor := crDefault;
  self.version_check(dbase.version);
end;

procedure TFrmMain.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
   if Panel.index = 2 then
     with statusbar.canvas do begin
      if (panel.text <> '') and (not unit_info_saved) then begin
        Brush.Color := clRed;
        Font.Color := clYellow;
      end else begin
        Brush.Color := clBtnface;
        Font.Color := clblack;
       end; 

      FillRect(Rect);
      TextOut(Rect.left + 30, Rect.top + 2, panel.text);
    end;
end;

procedure TFrmMain.check_dbase_changed;
var
  list, backup_list: TStringList;
begin
  list := TStringList.Create();
  try
    backup_list := TStringList.Create();
    try
      dbase.dbase_to_slist(list);
      dbase_backup.dbase_to_slist(backup_list);
      remove_duplicates(list, backup_list);
      if (list.count > 0) then
        unit_info_saved := false;
      update_status();
    finally
      backup_list.Free();
    end;
  finally
    list.Free();
  end;
end;

procedure TFrmMain.fit_chart;
var
   margin: double;
begin
  chart.bottomaxis.minimum := 0;
  chart.bottomaxis.maximum := series1.xvalues.maxvalue;
  margin := (chart.maxYvalue(chart.leftaxis) - chart.minYvalue(chart.leftaxis)) / 10;
  chart.leftaxis.maximum := chart.maxYvalue(chart.leftaxis) + margin;
  chart.leftaxis.minimum := chart.minYvalue(chart.leftaxis) - margin;
end;

procedure TFrmMain.Index1Click(Sender: TObject);
begin
  helpsocket.ShowIndexTAB;
end;

procedure TFrmMain.Contents1Click(Sender: TObject);
begin
 helpsocket.ShowTOCTab;
end;

function GetSelStr(addr : Integer) : String;
begin
  Result := Format('S%.2d;', [addr]);
end;

procedure TFrmMain.TSLogShow(Sender: TObject);
begin
  Print1.Caption := '&Print Log';
end;

procedure TFrmMain.TSLogHide(Sender: TObject);
begin
  Print1.Caption := '&Print Settings';
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  closing := true;
end;

procedure HandleBCA(reply : String);
begin
  if (reply = '?') then
  begin
     FrmMain.callback_timer := 0;
     FrmMain.waiting_for_callback := False;
     MessageDlg('Invalid Setting', mtError, [mbOK], 0);
  end
  else
  begin
    FrmMain.waiting_for_callback := False;
    FrmMain.callback_reply := reply;
  end;
end;

procedure TFrmMain.GetCalibrationFromIndicator(strs : TStrings);
var i : Integer;
    cmd : String;
    data : String;
begin
  for i := 0 to NumBCASettings - 1 do
  begin
    // Get calibration settings
    cmd := Format('BCA?%d;', [i]);
    if (SendStr_callback(cmd, False, '', HandleBCA) and
        (length(callback_reply) > 1)) then
    begin
      data := Format('BCA%d=%s', [i, callback_reply]);
      strs.Add(data);
    end
    else
    begin
      MessageDlg('Reading calibration information from indicator failed', mtWarning, [mbOK], 0);
    end;
  end;
end;

procedure TFrmMain.SendCalibrationToIndicator(const bcastrs : TStrings);
var i : Integer;
    cmd : String;
begin
  // Send calibration settings
  for i := 0 to bcastrs.Count - 1 do
  begin
    cmd := Format('BCA%s;', [bcastrs.Values[bcastrs.Names[i]]]);
    SendStr_callback(cmd, False, '', handle_OK);
  end;

  // Save settings
  PromptSaveCalibration();
end;

// Calculate checksum for storing calibration
//  result := $A5 + ord(s[1]) + ord(s[2]) + . . . .
function TFrmMain.CalcCalibrationChecksum(const s : String) : Integer;
var i : Integer;
begin
  Result := $A5;
  for i := 1 to Length(s) do
  begin
    Result := Result + Ord(s[i]);
  end;
end;

procedure TFrmMain.GetViewerVersionInfo(var viewversion : String; var viewproduct : String);
var CEVersionInfo: TCEVersionInfo;
begin
  CEVersionInfo := TCEVersionInfo.Create(nil);
  try
    CEVersionInfo.GetInfo(Application.ExeName);
    viewversion := CEVersionInfo.MajorVersion + '.' + CEVersionInfo.MinorVersion + '.' + CEVersionInfo.Release;
    viewproduct := CEVersionInfo.ProductName;
  finally
    CEVersionInfo.Free;
  end;
end;

procedure TFrmMain.GetViewerVersionTriplet(var view_vers_major, view_vers_minor, view_vers_release : String);
var CEVersionInfo: TCEVersionInfo;
begin
  CEVersionInfo := TCEVersionInfo.Create(nil);
  try
    CEVersionInfo.GetInfo(Application.ExeName);
    view_vers_major := CEVersionInfo.MajorVersion;
    view_vers_minor := CEVersionInfo.MinorVersion;
    view_vers_release := CEVersionInfo.Release;
  finally
    CEVersionInfo.Free;
  end;
end;

procedure TFrmMain.BackupCalibration(const filename : String);
var inifile : TIniFile;
    bcastrs : TStringList;
    i : Integer;
    chksum : Integer;
    viewversion : String;
    viewproduct : String;
begin
  // Save to INI file
  inifile := TIniFile.Create(filename);
  try
    bcastrs := TStringList.Create();
    try
      Self.GetCalibrationFromIndicator(bcastrs);
      Self.GetViewerVersionInfo(viewversion, viewproduct);
      inifile.WriteString('Header', 'ViewerProduct', viewproduct);
      inifile.WriteString('Header', 'ViewerVersion', viewversion);
      inifile.WriteString('Header', 'IndicatorModel', dbase.ID);
      inifile.WriteString('Header', 'IndicatorVersion', dbase.version);
      inifile.WriteString('Header', 'IndicatorSerialNo', dbase.serial);
      for i := 0 to bcastrs.Count - 1 do
      begin
        inifile.WriteString('CalData', bcastrs.Names[i], bcastrs.Values[bcastrs.Names[i]]);
      end;
      chksum := CalcCalibrationChecksum(bcastrs.Text);
      inifile.WriteInteger('CalData', 'Checksum', chksum);
    finally
      bcastrs.Free();
    end;
  finally
    inifile.Free;
  end;
end;

procedure TFrmMain.btnBackupCalClick(Sender: TObject);
var SaveDlg : TSaveDialog;
begin
  SetupForCalibration();
  try
    if (not FIOInterface.Connected) then
      raise Exception.Create('No instrument connected');

    SaveDlg := TSaveDialog.Create(nil);
    try
      SaveDlg.Title := 'Select filename for calibration data';
      SaveDlg.Filter := 'Calibration files (*.cal)|*.cal|All files (*.*)|*.*';
      SaveDlg.DefaultExt := 'cal';
      SaveDlg.Options := [ofOverwritePrompt];
      if (SaveDlg.Execute) then
      begin
        Self.BackupCalibration(SaveDlg.FileName);
      end;
    finally
      SaveDlg.Free();
    end;
  finally
    TeardownAfterCalibration();
  end;
end;

function TFrmMain.RestoreCalibration(const filename : String) : Boolean;
var inifile : TIniFile;
    bcastrs : TStringList;
    i : Integer;
    viewversion : String;
    viewproduct : String;
    bca : String;
    bcadata : String;
    readchksum : Integer;
    calcchksum : Integer;
    cont : Boolean;
begin
  Result := False;
  inifile := TIniFile.Create(filename);
  try
    bcastrs := TStringList.Create();
    try

      // Get app version info
      Self.GetViewerVersionInfo(viewversion, viewproduct);

      // Get calibration data from ini
      for i := 0 to NumBCASettings - 1 do
      begin
        bca := Format('BCA%d', [i]);
        bcadata := inifile.ReadString('CalData', bca, '');
        bcastrs.Add(bca + '=' + bcadata);
      end;

      // Get checksum from ini
      readchksum := inifile.ReadInteger('CalData', 'CheckSum', 0);
      calcchksum := Self.CalcCalibrationChecksum(bcastrs.Text);

      cont := true;

      // Check checksum over data
      if (readchksum <> calcchksum) then
      begin
        if MessageDlg('Stored checksum is incorrect. Continue?', mtWarning, [mbYes, mbNo], 0) = mrNo then
          cont := false;
      end;

      // Check viewer
      if (cont and (inifile.ReadString('Header', 'ViewerProduct', '') <> viewproduct)) then
      begin
        if MessageDlg('Viewer is different. Continue?', mtWarning, [mbYes, mbNo], 0) = mrNo then
          cont := false;
      end;

      // Check viewer version
      if (cont and (inifile.ReadString('Header', 'ViewerVersion', '') <> viewversion)) then
      begin
        if MessageDlg('Viewer version is different. Continue?', mtWarning, [mbYes, mbNo], 0) = mrNo then
          cont := false;
      end;

      // Check indicator model
      if (cont and (inifile.ReadString('Header', 'IndicatorModel', '') <> dbase.ID)) then
      begin
        if MessageDlg('Indicator model is different. Continue?', mtWarning, [mbYes, mbNo], 0) = mrNo then
          cont := false;
      end;

      // Check indicator software version
      if (cont and (inifile.ReadString('Header', 'IndicatorVersion', '') <> dbase.version)) then
      begin
        if MessageDlg('Indicator software version is different. Continue?', mtWarning, [mbYes, mbNo], 0) = mrNo then
          cont := false;
      end;

      // Indicator serial number
      if (cont and (inifile.ReadString('Header', 'IndicatorSerialNo', '') <> dbase.serial)) then
      begin
        if MessageDlg('C520 serial number is different. Continue?', mtWarning, [mbYes, mbNo], 0) = mrNo then
          cont := false;
      end;

      // Send to instrument
      if cont then
      begin
        Self.SendCalibrationToIndicator(bcastrs);
        Result := True;
      end;

    finally
      bcastrs.Free();
    end;
  finally
    inifile.Free();
  end;
end;

procedure TFrmMain.btnRestoreCalClick(Sender: TObject);
var OpenDlg : TOpenDialog;
    restored : Boolean;
begin
  restored := False;

  SetupForCalibration();
  try
    if (not FIOInterface.Connected) then
      raise Exception.Create('No instrument connected');

    OpenDlg := TOpenDialog.Create(nil);
    try
      OpenDlg.Title := 'Select filename containing calibration data';
      OpenDlg.Filter := 'Calibration files (*.cal)|*.cal|All files (*.*)|*.*';
      OpenDlg.DefaultExt := 'cal';
      OpenDlg.Options := [ofFileMustExist];

      if (OpenDlg.Execute()) then
      begin
        restored := Self.RestoreCalibration(OpenDlg.FileName);
      end;
    finally
      OpenDlg.Free();
    end;
  finally
    TeardownAfterCalibration();
  end;
  if (restored) then
    ReadSettings1Click(Self);
end;

procedure TFrmMain.btnCalDirectClick(Sender: TObject);
begin
  SetupForCalibration();
  try
    if (not FIOInterface.Connected) then
      raise Exception.Create('No instrument connected');

    // Convert zero and span mV/V value
    try
      dbase.directZero := Round(StrToFloat(edtCalDirectZero.Text) * 10000);
    except
      on E:EConvertError do
      begin
        raise Exception.Create('Invalid mV/V zero value. Calibration failed.');
      end;
    end;
    try
      dbase.directSpan := Round(StrToFloat(edtCalDirectSpan.Text) * 10000);
    except
      on E:EConvertError do
      begin
        raise Exception.Create('Invalid mV/V span value. Calibration failed.');
      end;
    end;

    // Check zero and span mV/V value
    if (dbase.directZero > 32000) then
      raise Exception.Create('Zero mV/V value error. Calibration failed because direct zero value too big. Must be <= 3.2mV/V');
    if (dbase.directZero < -32000) then
      raise Exception.Create('Zero mV/V value error. Calibration failed because direct zero value too small. Must be >= -3.2mV/V');
    if (dbase.directSpan > 32000) then
      raise Exception.Create('Span mV/V value error. Calibration failed because direct span value too big. Must be <= 3.2mV/V');
    if (dbase.directSpan < -32000) then
      raise Exception.Create('Span mV/V value error. Calibration failed because direct span value too small. Must be >= -3.2mV/V');
    if (dbase.directZero = dbase.directSpan) then
      raise Exception.Create('Calibration failed because span and zero mV/V values cannot be equal.');

    // Write values
    if (not SendStr_callback('LDN' + IntToStr(dbase.directZero), False, '', handle_ok)) then
      raise Exception.Create('Writing mV/V zero calibration value failed');
    WaitForCalibrationComplete('LDN');

    if (not SendStr_callback('LWN' + IntToStr(dbase.directSpan), False, '', handle_ok)) then
      raise Exception.Create('Writing mV/V span calibration value failed');
    WaitForCalibrationComplete('LWN');

    PromptSaveCalibration();
  finally
    TeardownAfterCalibration();
  end;
  ReadSettings1Click(self);
end;

procedure TFrmMain.MemoHeaderKeyPress(Sender: TObject; var Key: Char);
begin
  if (key > ' ') and (length(MemoHeader.Lines.Strings[MemoHeader.CaretPos.y]) >= 30) then begin
    ShowMessage('Maximum size = 6 lines x 30 characters');
    key := #0;
  end;
end;

procedure TFrmMain.ToolButton8Click(Sender: TObject);
var
  s : string;
  i : integer;
begin
  s := '';
  for i := 0 to NUM_HEADER_LINES-1 do
    s := s + inttostr(i) + ':' + dbase.prhdr[i] + CR + LF;
  ShowMessage(s);
end;

procedure TFrmMain.EthSetIpDefaults();
begin
  edtEthAddr1.Text      := '192'; edtEthAddr2.Text      := '168'; edtEthAddr3.Text      := '1';   edtEthAddr4.Text      := '254';
  edtEthMask1.Text      := '255'; edtEthMask2.Text      := '255'; edtEthMask3.Text      := '255'; edtEthMask4.Text      := '0';
  edtEthGW1.Text        := '192'; edtEthGW2.Text        := '168'; edtEthGW3.Text        := '1';   edtEthGW4.Text        := '1';
  edtEthDns1Octet1.Text := '192'; edtEthDns1Octet2.Text := '168'; edtEthDns1Octet3.Text := '1';   edtEthDns1Octet4.Text := '1';
  edtEthDns2Octet1.Text := '0';   edtEthDns2Octet2.Text := '0';   edtEthDns2Octet3.Text := '0';   edtEthDns2Octet4.Text := '0';
  edtEthDns3Octet1.Text := '0';   edtEthDns3Octet2.Text := '0';   edtEthDns3Octet3.Text := '0';   edtEthDns3Octet4.Text := '0';
end;

procedure TFrmMain.EthEnableDisableStaticBasedOnDHCPSetting();
var is_dhcp : Boolean;
begin
  is_dhcp := (cbEthDHCP.ItemIndex = 1);
  edtEthAddr1.Enabled := not is_dhcp;
  edtEthAddr2.Enabled := not is_dhcp;
  edtEthAddr3.Enabled := not is_dhcp;
  edtEthAddr4.Enabled := not is_dhcp;
  edtEthMask1.Enabled := not is_dhcp;
  edtEthMask2.Enabled := not is_dhcp;
  edtEthMask3.Enabled := not is_dhcp;
  edtEthMask4.Enabled := not is_dhcp;
  edtEthGW1.Enabled   := not is_dhcp;
  edtEthGW2.Enabled   := not is_dhcp;
  edtEthGW3.Enabled   := not is_dhcp;
  edtEthGW4.Enabled   := not is_dhcp;
  edtEthDns1Octet1.Enabled  := not is_dhcp;
  edtEthDns1Octet2.Enabled  := not is_dhcp;
  edtEthDns1Octet3.Enabled  := not is_dhcp;
  edtEthDns1Octet4.Enabled  := not is_dhcp;
  edtEthDns2Octet1.Enabled  := not is_dhcp;
  edtEthDns2Octet2.Enabled  := not is_dhcp;
  edtEthDns2Octet3.Enabled  := not is_dhcp;
  edtEthDns2Octet4.Enabled  := not is_dhcp;
  edtEthDns3Octet1.Enabled  := not is_dhcp;
  edtEthDns3Octet2.Enabled  := not is_dhcp;
  edtEthDns3Octet3.Enabled  := not is_dhcp;
  edtEthDns3Octet4.Enabled  := not is_dhcp;
  edtEthSearchDomain.Enabled := not is_dhcp;
end;

procedure TFrmMain.cbEthDHCPChange(Sender: TObject);

  function AllOctetsZero(const octets: TOctetArray) : Boolean;
  begin
    Result := (octets[0] = 0) and (octets[1] = 0) and (octets[2] = 0) and (octets[3] = 0);
  end;

  procedure DefaultIfAllSettingsZero;
  var eth_addr_octs, eth_mask_octs, eth_gatew_octs, eth_dns1_octs, eth_dns2_octs, eth_dns3_octs : TOctetArray;
      eth_addr_str, eth_mask_str, eth_gatew_str, eth_dns1_str, eth_dns2_str, eth_dns3_str : String;
  begin
    eth_addr_str := dbase.Ethernet_GetStrFromFields([edtEthAddr1.Text, edtEthAddr2.Text, edtEthAddr3.Text, edtEthAddr4.Text]);
    eth_mask_str := dbase.Ethernet_GetStrFromFields([edtEthMask1.Text, edtEthMask2.Text, edtEthMask3.Text, edtEthMask4.Text]);
    eth_gatew_str := dbase.Ethernet_GetStrFromFields([edtEthGW1.Text,  edtEthGW2.Text,   edtEthGW3.Text,   edtEthGW4.Text]);
    eth_dns1_str := dbase.Ethernet_GetStrFromFields([edtEthDns1Octet1.Text, edtEthDns1Octet2.Text, edtEthDns1Octet3.Text, edtEthDns1Octet4.Text]);
    eth_dns2_str := dbase.Ethernet_GetStrFromFields([edtEthDns2Octet1.Text, edtEthDns2Octet2.Text, edtEthDns2Octet3.Text, edtEthDns2Octet4.Text]);
    eth_dns3_str := dbase.Ethernet_GetStrFromFields([edtEthDns3Octet1.Text, edtEthDns3Octet2.Text, edtEthDns3Octet3.Text, edtEthDns3Octet4.Text]);
    dbase.Ethernet_GetIpOctetsFromStr(eth_addr_str,  '.', eth_addr_octs[0], eth_addr_octs[1], eth_addr_octs[2], eth_addr_octs[3]);
    dbase.Ethernet_GetIpOctetsFromStr(eth_mask_str,  '.', eth_mask_octs[0], eth_mask_octs[1], eth_mask_octs[2], eth_mask_octs[3]);
    dbase.Ethernet_GetIpOctetsFromStr(eth_gatew_str, '.', eth_gatew_octs[0], eth_gatew_octs[1], eth_gatew_octs[2], eth_gatew_octs[3]);
    dbase.Ethernet_GetIpOctetsFromStr(eth_dns1_str,  '.', eth_dns1_octs[0], eth_dns1_octs[1], eth_dns1_octs[2], eth_dns1_octs[3]);
    dbase.Ethernet_GetIpOctetsFromStr(eth_dns2_str,  '.', eth_dns2_octs[0], eth_dns2_octs[1], eth_dns2_octs[2], eth_dns2_octs[3]);
    dbase.Ethernet_GetIpOctetsFromStr(eth_dns3_str,  '.', eth_dns3_octs[0], eth_dns3_octs[1], eth_dns3_octs[2], eth_dns3_octs[3]);

    if AllOctetsZero(eth_addr_octs) and
       AllOctetsZero(eth_mask_octs) and
       AllOctetsZero(eth_gatew_octs) and
       AllOctetsZero(eth_dns1_octs) and
       AllOctetsZero(eth_dns2_octs) and
       AllOctetsZero(eth_dns3_octs) then
    begin
      if MessageDlg('IP settings are not currently set. Would you like to set them to defaults?',
                    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
        self.EthSetIpDefaults();
      end;
    end;
  end;

begin
  self.EthEnableDisableStaticBasedOnDHCPSetting();

  if (cbEthDHCP.ItemIndex = 0) then
  begin
    DefaultIfAllSettingsZero();
  end;
end;

procedure TFrmMain.CBxWeighModeChange(Sender: TObject);
begin
  Self.CBxWeightModeToRes();
end;

procedure TFrmMain.CBxWeightModeToRes();
begin
  if (CBxWeighMode.ItemIndex = 0) then
    begin
    EdtFs2.Enabled := false;
    CBxRes2.Enabled := false;
    end
  else
    begin
    EdtFs2.Enabled := true;
    CBxRes2.Enabled := true;
  end;
end;

procedure TFrmMain.SystemTimeToComboBoxes(hh, mn, ss, yy, mm, dd : word );
begin
            cbClkHour.ItemIndex := hh;
            cbClkMinute.ItemIndex := mn;
            cbClkSecond.ItemIndex := ss;
            cbClkYear.ItemIndex := yy;
            cbClkMonth.ItemIndex := mm-1;
            cbClkDay.ItemIndex := dd-1;
end;

procedure TFrmMain.CkBEnableToComboBoxes();
begin
   if (CkBQafEnable.Checked) then
      begin
      cbQafYear.Enabled := true;
      cbQafMonth.Enabled := true;
      cbQafDay.Enabled := true;
      end
   else
      begin
      cbQafYear.Enabled := false;
      cbQafMonth.Enabled := false;
      cbQafDay.Enabled := false;
   end;
end;

procedure TFrmMain.TcSerialIndexToComboBoxes();
begin
   case TcSerial.tabIndex of
      // Module 1A
      0:
      begin
         cbSerialUse.Enabled := true;
         cbBaud.Enabled := true;
         cbParity.Enabled := true;
         cbDataBits.Enabled := true;
         cbStopBits.Enabled := true;
         cbTermEn.Enabled := true;
         cbDtrEn.Enabled := true;
         cbHardware.Enabled := false;
      end;

      // Module 1B
      1:
      begin
         cbSerialUse.Enabled := true;
         cbBaud.Enabled := true;
         cbParity.Enabled := true;
         cbDataBits.Enabled := true;
         cbStopBits.Enabled := true;
         cbTermEn.Enabled := true;
         cbDtrEn.Enabled := false;
         cbHardware.Enabled := false;
      end;

      // Module 2A
      2:
      begin
         cbSerialUse.Enabled := true;
         cbBaud.Enabled := true;
         cbParity.Enabled := true;
         cbDataBits.Enabled := true;
         cbStopBits.Enabled := true;
         cbTermEn.Enabled := true;
         cbDtrEn.Enabled := true;
         cbHardware.Enabled := false;
      end;

      // Module 2B
      3:
      begin
         cbSerialUse.Enabled := true;
         cbBaud.Enabled := true;
         cbParity.Enabled := true;
         cbDataBits.Enabled := true;
         cbStopBits.Enabled := true;
         cbTermEn.Enabled := true;
         cbDtrEn.Enabled := false;
         cbHardware.Enabled := false;
      end;

      // USB Slave
      4:
      begin
         cbSerialUse.Enabled := true;
         cbBaud.Enabled := false;
         cbParity.Enabled := false;
         cbDataBits.Enabled := false;
         cbStopBits.Enabled := false;
         cbTermEn.Enabled := false;
         cbDtrEn.Enabled := false;
         cbHardware.Enabled := false;
      end;

      // USB Host
      5:
      begin
         cbSerialUse.Enabled := true;
         cbBaud.Enabled := true;
         cbParity.Enabled := true;
         cbDataBits.Enabled := true;
         cbStopBits.Enabled := true;
         cbTermEn.Enabled := false;
         cbDtrEn.Enabled := false;
         cbHardware.Enabled := false;
      end;

      // Serial 1
      6:
      begin
         cbSerialUse.Enabled := true;
         cbBaud.Enabled := true;
         cbParity.Enabled := true;
         cbDataBits.Enabled := true;
         cbStopBits.Enabled := true;
         cbTermEn.Enabled := false;
         cbDtrEn.Enabled := false;
         cbHardware.Enabled := true;
      end;

   else
      cbSerialUse.Enabled := true;
      cbBaud.Enabled := true;
      cbParity.Enabled := true;
      cbDataBits.Enabled := true;
      cbStopBits.Enabled := true;
      cbTermEn.Enabled := true;
      cbDtrEn.Enabled := true;
      cbHardware.Enabled := false;
   end;
end;   

procedure TFrmMain.TcSerialIndexToUseItems();
var
  useListSerialModuleXa : TStringList;
  useListSerialModuleXb : TStringList;
  useListSerialModuleSlv : TStringList;
  useListSerialModuleHst : TStringList;
  useListSerial12 : TStringList;
begin
  useListSerialModuleXa := TStringList.Create();
  useListSerialModuleXb := TStringList.Create();
  useListSerialModuleSlv := TStringList.Create();
  useListSerialModuleHst := TStringList.Create();
  useListSerial12 := TStringList.Create();

  useListSerialModuleXa.Add('Off');
  useListSerialModuleXa.Add('Auto.lo');
  useListSerialModuleXa.Add('Auto.hi');
  useListSerialModuleXa.Add('Print');
  useListSerialModuleXa.Add('Single');
  useListSerialModuleXa.Add('Net');
  useListSerialModuleXa.Add('MB Legacy');

  useListSerialModuleXb.Add('Off');
  useListSerialModuleXb.Add('Auto.lo');
  useListSerialModuleXb.Add('Auto.hi');
  useListSerialModuleXb.Add('Print');
  useListSerialModuleXb.Add('Single');

  useListSerialModuleSlv.Add('Off');
  useListSerialModuleSlv.Add('Auto.lo');
  useListSerialModuleSlv.Add('Auto.hi');
  useListSerialModuleSlv.Add('Print');
  useListSerialModuleSlv.Add('Single');
  useListSerialModuleSlv.Add('Net');

  useListSerialModuleHst.Add('Off');
  useListSerialModuleHst.Add('Auto.lo');
  useListSerialModuleHst.Add('Auto.hi');
  useListSerialModuleHst.Add('Print');
  useListSerialModuleHst.Add('Single');
  useListSerialModuleHst.Add('Net');
  useListSerialModuleHst.Add('MB Legacy');
  useListSerialModuleHst.Add('MB Ascii');
  useListSerialModuleHst.Add('MB RTU');

  useListSerial12.Add('Off');
  useListSerial12.Add('Auto.lo');
  useListSerial12.Add('Auto.hi');
  useListSerial12.Add('Print');
  useListSerial12.Add('Single');
  useListSerial12.Add('Net');
  useListSerial12.Add('MB Legacy');

  cbSerialUse.Clear();

  case TcSerial.tabIndex of
    0,2: cbSerialUse.Items := useListSerialModuleXa;
    1,3: cbSerialUse.Items := useListSerialModuleXb;
      4: cbSerialUse.Items := useListSerialModuleSlv;
      5: cbSerialUse.Items := useListSerialModuleHst;
      6: cbSerialUse.Items := useListSerialModuleXa;  // Serial 1
      7: cbSerialUse.Items := useListSerialModuleXa;  // Serial 2
  else
    cbSerialUse.Items := useListSerialModuleXa;
  end;
  useListSerialModuleXa.Free();
  useListSerialModuleXb.Free();
  useListSerialModuleSlv.Free();
  useListSerialModuleHst.Free();
  useListSerial12.Free();
end;

function TFrmMain.TcSerialIndexToTBDXPort : TBDXPort;
begin
  case TcSerial.tabIndex of
    0: Result := BDXMod1A;
    1: Result := BDXMod1B;
    2: Result := BDXMod2A;
    3: Result := BDXMod2B;
    4: Result := BDXUsbSlave;
    5: Result := BDXUsbHost;
    6: Result := BDXSerial1;
    7: Result := BDXSerial2;
  else
    Result := BDXMod1A;
  end;
end;

procedure TFrmMain.tcSerialChange(Sender: TObject);
var bdx : TBDXPort;
begin

  Self.TcSerialIndexToUseItems();
  Self.TcSerialIndexToComboBoxes();
  bdx := Self.TcSerialIndexToTBDXPort();
  cbSerialUse.ItemIndex := dbase.portData14[bdx].use;
  cbBaud.ItemIndex      := dbase.portData14[bdx].baud;
  cbParity.ItemIndex    := dbase.portData14[bdx].parity;
  cbDatabits.ItemIndex  := dbase.portData14[bdx].databits;
  cbStopbits.ItemIndex  := dbase.portData14[bdx].stopbits;
  cbTermEn.ItemIndex    := dbase.portData14[bdx].termEn;
  cbDtrEn.ItemIndex     := dbase.portData14[bdx].dtrEn;
  cbHardware.ItemIndex  := dbase.portData14[bdx].rs232En;

  // if viewer port, then disable editting
{  cbSerialUse.Enabled := (dbase.CurrentViewerPort <> TcSerial.tabIndex);
  cbBaud.Enabled      := (dbase.CurrentViewerPort <> TcSerial.tabIndex);
  cbParity.Enabled    := (dbase.CurrentViewerPort <> TcSerial.tabIndex);
  cbDatabits.Enabled  := (dbase.CurrentViewerPort <> TcSerial.tabIndex);
  cbStopbits.Enabled  := (dbase.CurrentViewerPort <> TcSerial.tabIndex);
  cbTermEn.Enabled    := (dbase.CurrentViewerPort <> TcSerial.tabIndex);
  cbDtrEn.Enabled     := (dbase.CurrentViewerPort <> TcSerial.tabIndex);
  cbHardware.Enabled  := (dbase.CurrentViewerPort <> TcSerial.tabIndex);}
end;

procedure TFrmMain.cbSerialChange(Sender: TObject);
var bdx : TBDXPort;
begin
  bdx := Self.TcSerialIndexToTBDXPort();
  if (dbase.CurrentViewerPort = integer(bdx)) then begin
    // if viewer port, then reload settings and disable exitting
    tcserialchange(self);
  end else begin
    dbase.portData14[bdx].use      := cbSerialUse.ItemIndex;
    dbase.portData14[bdx].baud     := cbBaud.ItemIndex;
    dbase.portData14[bdx].parity   := cbParity.ItemIndex;
    dbase.portData14[bdx].databits := cbDatabits.ItemIndex;
    dbase.portData14[bdx].stopbits := cbStopbits.ItemIndex;
    dbase.portData14[bdx].termEn   := cbTermEn.ItemIndex;
    dbase.portData14[bdx].dtrEn    := cbDtrEn.ItemIndex;
    dbase.portData14[bdx].rs232En  := cbHardware.ItemIndex;
  end;
end;

procedure TFrmMain.MnuDeviceFinderClick(Sender: TObject);
var frmNetworkDevices : TFrmNetworkDevices;
begin
  frmNetworkDevices := TFrmNetworkDevices.Create(nil);
  try
    // Can only connect if not already connected
    frmNetworkDevices.CanConnect := not FIOInterface.Connected;
    frmNetworkDevices.ModalResult := mrNone;
    frmNetworkDevices.LookUpAddress := datViewer.DeviceFinderLookupAddress;
    if (mrOk = frmNetworkDevices.ShowModal()) then
    begin
      datViewer.ConnectionType := ctTcp;
      datViewer.TcpHostname := frmNetworkDevices.ConnectAddress;
      try
        datViewer.TcpPort := StrToInt(frmNetworkDevices.ConnectTcpPort);
      except
      end;
      ConnectDisconnect();
    end;
    datViewer.DeviceFinderLookupAddress := frmNetworkDevices.LookUpAddress;
  finally
    frmNetworkDevices.Free();
  end;
end;

procedure TFrmMain.PopulateDecimalPointDialog(dpchar : Char);
var oldidx : Integer;
begin
  oldidx := CBxDP.ItemIndex;
  CBxDP.Clear();
  CBxDP.Items.Add('123456');
  CBxDP.Items.Add(Format('12345 %s 6', [dpchar]));
  CBxDP.Items.Add(Format('1234 %s 56', [dpchar]));
  CBxDP.Items.Add(Format('123 %s 456', [dpchar]));
  CBxDP.Items.Add(Format('12 %s 3456', [dpchar]));
  CBxDP.Items.Add(Format('1 %s 23456', [dpchar]));
  CBxDP.ItemIndex := oldidx;
end;

procedure TFrmMain.UpdateDecimalPointCharChange;
var dpc : Char;
begin
  dpc := datViewer.DecimalPointChar;
  Self.PopulateDecimalPointDialog(dpc);
  Self.UpdateDialogDecimalPoints();
end;

procedure TFrmMain.mnuDPPointClick(Sender: TObject);
begin
  mnuDPPoint.Checked := True;
  datViewer.DecimalPointChar := '.';
  Self.UpdateDecimalPointCharChange();
end;

procedure TFrmMain.mnuDPCommaClick(Sender: TObject);
begin
  mnuDPComma.Checked := True;
  datViewer.DecimalPointChar := ',';
  Self.UpdateDecimalPointCharChange();
end;

procedure TFrmMain.edtAddTareKeyPress(Sender: TObject; var Key: Char);
var Edit : TEdit;
begin
  case key of
    ' ','+','-','.',',':
      ;
    #13:
    begin
      if (Sender is TEdit) then
      begin
        Edit := Sender as TEdit;
        Edit.Text := fmt_num(Edit.Text, CBxDp.ItemIndex, datViewer.DecimalPointChar);
        key := #0;
      end;
    end;
  else
    if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then
      key := #0;
  end;
end;

procedure TFrmMain.edtAddTareExit(Sender: TObject);
var Edit : TEdit;
    adtare : Integer;
    fs : Integer;
begin
  if Sender is TEdit then
  begin
    Edit := Sender as TEdit;
    Edit.Text := fmt_num(Edit.Text, CBxDp.ItemIndex, datViewer.DecimalPointChar);
    adtare := my_strtoint(Edit.Text);
    if (CBxWeighMode.ItemIndex = 1) or (CBxWeighMode.ItemIndex = 2) then
      fs := my_strtoint(EdtFS2.Text)
    else
      fs := my_strtoint(EdtFS1.Text);
    if (adtare > fs) or (adtare < 0) then
    begin
      MessageDlg(Format('Out of Range: (%s to %s)',
                        [fmt_int(0, CBxDp.ItemIndex, datViewer.DecimalPointChar),
                         fmt_int(fs, CBxDp.ItemIndex, datViewer.DecimalPointChar)]),
                 mtError, [mbOK], 0);
      SetFocus;
    end;
  end;
end;

procedure TFrmMain.EditOptions;
var frmOptions : TfrmOptions;
begin
  frmOptions := TfrmOptions.Create(nil);
  try
    frmOptions.ShowModal;

    CommsTimeout := datViewer.Timeout;
  finally
    frmOptions.Free;
  end;
end;

procedure TFrmMain.FormShow(Sender: TObject);
begin
  if datViewer.firstRun then
  begin
    Self.EditOptions();
  end;
end;

procedure TFrmMain.MnuOptionsClick(Sender: TObject);
begin
  Self.EditOptions();
end;

procedure TFrmMain.edtEthHostnameExit(Sender: TObject);
var str : String;
    i : Integer;
    minlen : Integer;
    maxlen : Integer;
    charset : TCharSet;
    desc : String;
    msg : String;
begin
  if (Sender = edtEthHostname) then
  begin
    minlen := 1;
    maxlen := 64;
    charset := tools.CharsetHostname;
    str := edtEthHostname.Text;
    desc := 'hostname';
  end
  else if (Sender = edtEthSearchDomain) then
  begin
    minlen := 0;
    maxlen := 255;
    charset := tools.CharsetDomainname;
    str := edtEthSearchDomain.Text;
    desc := 'search domain';
  end
  else if (Sender = EdtId) then
  begin
    minlen := 0;
    maxlen := 15;
    charset := tools.CharsetIndicatorId;
    str := EdtId.Text;
    desc := 'indicator id';
  end
  else
  begin
    Exit;
  end;

  if (Length(str) < minlen) or (Length(str) > maxlen) then
  begin
    msg := Format('Invalid length for %s %d, should be between %d..%d', [ desc, Length(str), minlen, maxlen ]);
    MessageDlg(msg, mtError, [mbOK], 0);
    SetFocus();
    Exit;
  end;

  for i := 1 to Length(str) do
  begin
    if (not (str[i] in charset)) then
    begin
      msg := Format('Character "%s" at position %d is not valid for %s', [ str[i], i, desc ]);
      MessageDlg(msg, mtError, [mbOK], 0);
      SetFocus();
      Exit;
    end;
  end;
end;

procedure TFrmMain.ChartDblClick(Sender: TObject);
var xmin, ymin : Double;
    xmax, ymax : Double;
    ymargin : Double;
begin
  xmax := Series1.XValues.MaxValue;
  xmin := Series1.XValues.MinValue;

  ymax := Chart.MaxYValue(Chart.LeftAxis);
  ymin := Chart.MinYValue(Chart.LeftAxis);
  ymargin := (ymax - ymin) / 10;

  Chart.LeftAxis.Minimum := ymin - ymargin;
  Chart.LeftAxis.Maximum := ymax + ymargin;
  Chart.BottomAxis.Minimum := xmin;
  Chart.BottomAxis.Maximum := xmax;
end;

procedure TFrmMain.ClearChart1Click(Sender: TObject);
var i : Integer;
begin
  for i := 0 to Chart.SeriesCount - 1 do
    Chart.SeriesList.Series[i].Clear();
end;

procedure TFrmMain.CkBQafEnableClick(Sender: TObject);
begin
   Self.CkBEnableToComboBoxes();
end;

procedure TFrmMain.btnSysClockClick(Sender: TObject);
var
  timedate  : Tdatetime;
  dd, mm, yy, hh, mn, ss, msec: word;

begin
  timeChanged := true;
  timedate := Now;
  DecodeDate(timedate, yy, mm, dd);
  if (yy > 1999) then yy := yy - 2000;
  Decodetime(timedate, hh, mn, ss, msec);
  self.SystemTimeToComboBoxes(hh, mn, ss, yy, mm, dd);
end;

procedure TFrmMain.cbClkHourChange(Sender: TObject);
begin
   timeChanged := true;
end;

procedure TFrmMain.cbClkMinuteChange(Sender: TObject);
begin
   timeChanged := true;
end;

procedure TFrmMain.cbClkSecondChange(Sender: TObject);
begin
   timeChanged := true;
end;

procedure TFrmMain.cbClkYearChange(Sender: TObject);
begin
   timeChanged := true;
end;

procedure TFrmMain.cbClkMonthChange(Sender: TObject);
begin
   timeChanged := true;
end;

procedure TFrmMain.cbClkDayChange(Sender: TObject);
begin
   timeChanged := true;
end;

procedure TFrmMain.EdtConversionFactorKeyPress(Sender: TObject;
  var Key: Char);
var Edit : TEdit;
begin
  case key of
    ' ','+','-','.',',':
      ;
    #13:
    begin
      if (Sender is TEdit) then
      begin
        Edit := Sender as TEdit;
        Edit.Text := fmt_num(Edit.Text, dp_posn[Edit.Tag], datViewer.DecimalPointChar);
        key := #0;
      end;
    end;
  else
    if ((ord(key) >= ord(' ')) and (ord(key) < ord('0'))) or (ord(key) > ord('9')) then
      key := #0;
  end;
end;

procedure TFrmMain.EdtConversionFactorExit(Sender: TObject);
var Edit : TEdit;
begin
  if Sender is TEdit then
  begin
    Edit := Sender as TEdit;
    Edit.Text := fmt_num(Edit.Text, dp_posn[Edit.Tag], datViewer.DecimalPointChar);
    if not chk_num(Edit.Text, Edit.Tag) then
    begin
      MessageDlg(Format('Out of Range: (%s to %s)',
                        [fmt_int(min_val[Edit.Tag], dp_posn[Edit.Tag], datViewer.DecimalPointChar),
                         fmt_int(max_val[Edit.Tag], dp_posn[Edit.Tag], datViewer.DecimalPointChar)]),
                 mtError, [mbOK], 0);
      SetFocus;
    end;
  end;
end;

procedure TFrmMain.CBSerialAutoTypeChange(Sender: TObject);
begin
  if (CBSerialAutoType.ItemIndex < 1) or (CBSerialAutoType.ItemIndex > 2) then
  begin
    MessageDlg(Format('This port can only be Auto.Lo or Auto.Hi', []),
               mtError, [mbOK], 0);
    CBSerialAutoType.ItemIndex := 1;
  end;
end;

procedure TFrmMain.BitBtnStaticIpDefaultsClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to disable DHCP and set the IP settings to defaults?',
                mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    cbEthDHCP.ItemIndex := 0;
    self.EthEnableDisableStaticBasedOnDHCPSetting();
    self.EthSetIpDefaults();
  end;
end;

end.

