unit option;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, NumEdit;

type
  TfrmOptions = class(TForm)
    GroupBox1: TGroupBox;
    edtSerialTimeout: TNumEdit;
    edtTCPTimeout: TNumEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure edtSerialTimeoutExitError(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

//var
//  frmOptions: TfrmOptions;

implementation

{$R *.DFM}
uses dmviewer;

procedure TfrmOptions.FormShow(Sender: TObject);
begin
  edtSerialTimeout.Text := FloatToStr(datViewer.SerTimeout / 10);
  edtTCPTimeout.Text := FloatToStr(datViewer.TcpTimeout / 10);
end;

procedure TfrmOptions.btnOKClick(Sender: TObject);
begin
  datViewer.SerTimeout := Round(edtSerialTimeout.GetReal * 10);
  datViewer.TcpTimeout := Round(edtTCPTimeout.GetReal * 10);
  ModalResult := mrOK;
end;

procedure TfrmOptions.btnCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmOptions.edtSerialTimeoutExitError(Sender: TObject);
begin
  MessageDlg('The number must be within the range 0.5s to 20s', mtWarning, [mbOK], 0);
end;

procedure TfrmOptions.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  datViewer.firstRun := False;
end;

end.
